VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cIFan"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'  class cIFan
'
'  Impulse Fan Data
'
Private sFanQ As String * 10         ' This & below for impulse fans only
Private sFEff As String * 10
Private sFVel As String * 10
Private iTmOn As Integer
Private iTmOff As Integer

Public Property Get FanQ() As String
    FanQ = sFanQ
End Property

Public Sub GetIFan(FanQ As String, Feff As String, _
    fVel As String, TmOn As Integer, TmOff As Integer)
    FanQ = sFanQ
    Feff = sFEff
    fVel = sFVel
    TmOn = iTmOn
    TmOff = iTmOff
    
End Sub

Public Sub SetIFan(FanQ As String, Feff As String, _
    fVel As String, TmOn As Integer, TmOff As Integer)
    sFanQ = FanQ
    sFEff = Feff
    sFVel = fVel
    iTmOn = TmOn
    iTmOff = TmOff
    
End Sub

Public Function ReadData() As Boolean
Dim t1, t2, t3, t4, t5, t6, t7, t8
    On Error GoTo ReadError
    ReadData = False
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sFanQ = t1
    sFEff = t2
    sFVel = t3
    iTmOn = Val(t4)
    iTmOff = Val(t5)
    ReadData = True
ReadError:
    
End Function

Public Sub WriteData()
' Write data for one impulse fan to data file
    Print #1, sFanQ; sFEff; sFVel; IStr(iTmOn); IStr(iTmOff)
    
End Sub

Public Sub XCopy(ff As cIFan)
' Copy the data from ff
Dim s1 As String, s2 As String, s3 As String
    ff.GetIFan s1, s2, s3, iTmOn, iTmOff
    sFanQ = s1
    sFEff = s2
    sFVel = s3
    
End Sub

Private Sub Class_Initialize()
    sFanQ = Zero
    sFEff = Zero
    sFVel = Zero
    iTmOn = 0
    iTmOff = 0
End Sub
