VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cNode"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       cNode.cls

Private iID As Integer
Private iAType As Integer
Private iTType As Integer
Private sTD1 As String * 10
Private sTD2 As String * 10
Private sTD3 As String * 10
Private sTD4 As String * 10
Private sTD5 As String * 10
Private sTD6 As String * 10
Private sTD7 As String * 10
Private iID1 As Integer
Private iID2 As Integer
Private iID3 As Integer
Private iID4 As Integer
Private sAR As String * 10
Private sAngle As String * 10

Public Property Let AType(ii As Integer)
    If (iAType >= 0 And iAType < 6) Or iAType = 7 Then iAType = ii
End Property

Public Sub GetA1(i1 As Integer, i2 As Integer, i3 As Integer, _
    i4 As Integer, AR As String)
' Get data for Aero Type 1 Node
    i1 = iID1
    i2 = iID2
    i3 = iID3
    i4 = iID4
    AR = sAR
    
End Sub

Public Sub GetA2(i1 As Integer, i2 As Integer, i3 As Integer)
' Get data for Aero Type 2 Node
    i1 = iID1
    i2 = iID2
    i3 = iID3
    
End Sub

Public Sub GetA3(i1 As Integer, i2 As Integer, i3 As Integer, _
     AR As String)
' Get data for Aero Type 3 Node
    i1 = iID1
    i2 = iID2
    i3 = iID3
    AR = sAR
    
End Sub

Public Sub GetA4(i1 As Integer, i2 As Integer, i3 As Integer, _
     AR As String, AA As String)
' Get data for Aero Type 4 Node
    i1 = iID1
    i2 = iID2
    i3 = iID3
    AR = sAR
    AA = sAngle
    
End Sub

Public Sub GetA5(i1 As Integer, i2 As Integer, i3 As Integer, _
    AR As String, AA As String)
' Get data for Aero Type 5 Node
    i1 = iID1
    i2 = iID2
    i3 = iID3
    AR = sAR
    AA = sAngle
    
End Sub

Public Sub SetA1(i1 As Integer, i2 As Integer, i3 As Integer, _
    i4 As Integer, AR As String)
' Set data for Aero Type 1 Node
    iID1 = i1
    iID2 = i2
    iID3 = i3
    iID4 = i4
    sAR = AR
    
End Sub

Public Sub SetA2(i1 As Integer, i2 As Integer, i3 As Integer)
' Set data for Aero Type 2 Node
    iID1 = i1
    iID2 = i2
    iID3 = i3
    
End Sub

Public Sub SetA3(i1 As Integer, i2 As Integer, i3 As Integer, _
    AR As String)
' Set data for Aero Type 3 Node
    iID1 = i1
    iID2 = i2
    iID3 = i3
    sAR = AR
    
End Sub

Public Sub SetA4(i1 As Integer, i2 As Integer, i3 As Integer, _
    AR As String, AA As String)
' Set data for Aero Type 4 Node
    iID1 = i1
    iID2 = i2
    iID3 = i3
    sAR = AR
    sAngle = AA
    
End Sub

Public Sub SetA5(i1 As Integer, i2 As Integer, i3 As Integer, _
    AR As String, AA As String)
' Set data for Aero Type 5 Node
    iID1 = i1
    iID2 = i2
    iID3 = i3
    sAR = AR
    sAngle = AA
    
End Sub


Public Sub GetT3(s1 As String, s2 As String, s3 As String, _
    s4 As String, s5 As String, s6 As String)
' Get data for Thermo Type 3 Node
    s1 = sTD1
    s2 = sTD2
    s3 = sTD3
    s4 = sTD4
    s5 = sTD5
    s6 = sTD6
    
End Sub

Public Sub SetT2(s1 As String, s2 As String, s3 As String, _
    s4 As String, s5 As String, s6 As String, s7 As String)
' Get data for Thermo Type 3 Node
    sTD1 = s1
    sTD2 = s2
    sTD3 = s3
    sTD4 = s4
    sTD5 = s5
    sTD6 = s6
    sTD7 = s7
    
End Sub

Public Sub SetT3(s1 As String, s2 As String, s3 As String, _
    s4 As String, s5 As String, s6 As String)
' Get data for Thermo Type 3 Node
    sTD1 = s1
    sTD2 = s2
    sTD3 = s3
    sTD4 = s4
    sTD5 = s5
    sTD6 = s6
    
End Sub


Public Sub GetT2(s1 As String, s2 As String, s3 As String, _
    s4 As String, s5 As String, s6 As String, s7 As String)
' Get data for Thermo Type 2 Node
    s1 = sTD1
    s2 = sTD2
    s3 = sTD3
    s4 = sTD4
    s5 = sTD5
    s6 = sTD6
    s7 = sTD7
End Sub


Public Function ReadData() As Boolean
Dim LL$
Dim t1, t2, t3, t4, t5, t6, t7, t8
    ReadData = False
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    iID = Val(t1)
    iAType = Val(t2)
    iTType = Val(t3)
    If iTType = 3 Then     ' Form 6B
        If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
        sTD1 = t1
        sTD2 = t2
        sTD3 = t3
        sTD4 = t4
        sTD5 = t5
        sTD6 = t6
    End If
    Select Case iAType
    Case 1
        If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
        iID1 = Val(t1)
        iID2 = Val(t2)
        iID3 = Val(t3)
        iID4 = Val(t4)
        sAR = t5
    Case 2
        If Not GetFour(t1, t2, t3, t4) Then Exit Function
        iID1 = Val(t1)
        iID2 = Val(t2)
        iID3 = Val(t3)
    Case 3
        If Not GetFour(t1, t2, t3, t4) Then Exit Function
        iID1 = Val(t1)
        iID2 = Val(t2)
        iID3 = Val(t3)
        sAR = t4
    Case 4
        If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
        iID1 = Val(t1)
        iID2 = Val(t2)
        iID3 = Val(t3)
        sAR = t4
        sAngle = t5
    Case 5
        If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
        iID1 = Val(t1)
        iID2 = Val(t2)
        iID3 = Val(t3)
        sAR = t4
        sAngle = t5
    End Select
    If iTType = 2 Then     ' Form 6H
        If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
        sTD1 = t1
        sTD2 = t2
        sTD3 = t3
        sTD4 = t4
        sTD5 = t5
        sTD6 = t6
        sTD7 = t7
    End If
    ReadData = True
    
End Function


Public Property Let TType(ii As Integer)
    If ii > 0 And ii <= 3 Then iTType = ii
    
End Property

Public Property Get TType() As Integer
    TType = iTType
    
End Property

Public Sub WriteData()
' Write data for one node
    Print #1, IStr(iID); IStr(iAType); IStr(iTType)
    If iTType = 3 Then
        Print #1, sTD1; sTD2; sTD3; sTD4; sTD5; sTD6
    End If
    
    Select Case iAType
    Case 1
        Print #1, IStr(iID1); IStr(iID2); IStr(iID3); IStr(iID4); sAR
    Case 2
        Print #1, IStr(iID1); IStr(iID2); IStr(iID3)
    Case 3
        Print #1, IStr(iID1); IStr(iID2); IStr(iID3); sAR
    Case 4, 5
        Print #1, IStr(iID1); IStr(iID2); IStr(iID3); sAR; sAngle
    End Select
    
    If iTType = 2 Then
        Print #1, sTD1; sTD2; sTD3; sTD4; sTD5; sTD6; sTD7
    End If
    
End Sub

Public Property Get Branched()
    Branched = iAType > 0
    
End Property

Public Property Get id() As Integer
    id = iID
End Property

Public Property Let id(ii As Integer)
    If ii > 0 And ii <= 999 Then iID = ii
    
End Property


Public Property Get AType() As Integer
    AType = iAType
End Property


Public Sub XCopy(nn As cNode)
' copy data from node nn
    iAType = nn.AType
    iTType = nn.TType
    
    Select Case iAType
    Case 1
        nn.GetA1 iID1, iID2, iID3, iID4, sAR
    Case 2
        nn.GetA2 iID1, iID2, iID3
    Case 3
        nn.GetA3 iID1, iID2, iID3, sAR
    Case 4
        nn.GetA4 iID1, iID2, iID3, sAR, sAngle
    Case 5
        nn.GetA5 iID1, iID2, iID3, sAR, sAngle
    End Select
    
    Select Case iTType
    Case 2
        nn.GetT2 sTD1, sTD2, sTD3, sTD4, sTD5, sTD6, sTD7
    Case 3
        nn.GetT3 sTD1, sTD2, sTD3, sTD4, sTD5, sTD6
    End Select
    
End Sub

Private Sub Class_Initialize()
    iID = 0
    iAType = 0
    iTType = 1
    sTD1 = Zero
    sTD2 = Zero
    sTD3 = Zero
    sTD4 = Zero
    sTD5 = Zero
    sTD6 = Zero
    sTD7 = Zero
    iID1 = 0
    iID2 = 0
    iID3 = 0
    iID4 = 0

End Sub
