VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cSSHS"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       cSSHS.cls

Private NStart As Integer      ' first subsegment number
Private NStop As Integer       ' last subsegment number
Private nType As Integer        ' type of heat source
Private sHSens As String * 10       ' amount of sensible heat
Private sHLatent As String * 10 ' Amount of latent heat
Private sid As String * 30       ' Description of heat source


Public Function ReadData() As Boolean
' read the data for this heat source from the data file
Dim LL$
    On Error GoTo InErr
    Line Input #1, LL$
    NStart = Val(Mid$(LL$, 1, 10))
    NStop = Val(Mid$(LL$, 11, 10))
    nType = Val(Mid$(LL$, 21, 10))
    sHSens = Mid$(LL$, 31, 10)
    sHLatent = Mid$(LL$, 41, 10)
    sid = Mid$(LL$, 51, 30)
    ReadData = True
    Exit Function
InErr:
    ReadData = False

End Function

Public Sub setSSHS(n1 As Integer, n2 As Integer, T As Integer, _
    HS As String, HL As String, id As String)
    NStart = n1
    NStop = n2
    nType = T
    sHSens = HS
    sHLatent = HL
    sid = id
    
End Sub


Public Sub getSSHS(n1 As Integer, n2 As Integer, T As Integer, _
    HS As String, HL As String, id As String)
    n1 = NStart
    n2 = NStop
    T = nType
    HS = sHSens
    HL = sHLatent
    id = sid
    
End Sub

Public Sub WriteData()
' The null strings in the following print statement are inserted to work around
' an apparent VB4.0 bug.  The nType field was dropped entirely without them.
    Print #1, IStr(NStart); IStr(NStop); ""; IStr(nType); ""; sHSens; sHLatent; sid
End Sub

Public Sub XCopy(ss As cSSHS)
' copy the data from ss
    ss.getSSHS NStart, NStop, nType, sHSens, sHLatent, sid
    
End Sub

Private Sub Class_Initialize()
    NStart = 1
    NStop = 1
    nType = 1
    sHSens = "100"
    sHLatent = "100"
    sid = "Heat"
    ' Set pSSHS = Nothing
    
End Sub


