VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cSubSeg"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       cSubSeg.cls
    
Private NStart As Integer        ' First subsegment
Private NStop As Integer          ' Last subsegment
Private sTWall As String * 10        ' Wall Temperature
Private sTDry As String * 10         ' Dry-bulb Temperature
Private sTWet As String * 10         ' Wet-bulb Temperature

Public Sub getSubSeg(n1 As Integer, n2 As Integer, _
    twall As String, tdry As String, twet As String)
    n1 = NStart
    n2 = NStop
    twall = sTWall
    tdry = sTDry
    twet = sTWet
    
End Sub

Public Function ReadData() As Boolean
' read values for this subsegment from the data file
Dim t1, t2, t3, t4, t5, t6, t7, t8
    On Error GoTo InErr
    GetLine t1, t2, t3, t4, t5, t6, t7, t8
    NStart = Val(t1)
    NStop = Val(t2)
    sTWall = t3
    sTDry = t4
    sTWet = t5
    ReadData = True
    Exit Function
InErr:
    ReadData = False
    
End Function

Public Sub setSubSeg(n1 As Integer, n2 As Integer, _
    twall As String, tdry As String, twet As String)
    NStart = n1
    NStop = n2
    sTWall = twall
    sTDry = tdry
    sTWet = twet
    
End Sub

Public Sub updateSubSeg(twall As String, tdry As String, twet As String)
' set subsegment temperatures without changing
    sTWall = twall
    sTDry = tdry
    sTWet = twet

End Sub

Public Property Get SStop() As Integer
    SStop = NStop
    
End Property


Public Sub WriteData()
' Write one subsegment record
    Print #1, IStr(NStart); IStr(NStop); sTWall; sTDry; sTWet
    
End Sub

Public Sub XCopy(src As cSubSeg)
'  copy values from the argument
    src.getSubSeg NStart, NStop, sTWall, sTDry, sTWet
    
End Sub


Private Sub Class_Initialize()
    NStart = 1
    NStop = 1
    sTWall = "60."
    sTDry = "60."
    sTWet = "60."
    
End Sub


