VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cVent"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       cVent.cls
' This class contains the data for vent sections.
' Vent section objects are contained in a cVents object
' defined in SESDS.

Private iID As Integer
Private iStartNode As Integer
Private iStopNode As Integer
Private sInitAir As String * 10

Public uVShaft As cVShaft


Property Get id() As Integer
    id = iID
    
End Property

Property Let id(ii As Integer)
    iID = ii
    
End Property


Property Get InitAir() As String
    InitAir = sInitAir
    
End Property

Property Let InitAir(sAir As String)
    sInitAir = sAir
    
End Property

Public Function ReadFile() As Boolean
' Read the vent section record from the input file
Dim t1, t2, t3, t4, t5, t6, t7, t8
    On Error GoTo InErr
    GetLine t1, t2, t3, t4, t5, t6, t7, t8
    iID = Val(t1)
    iStartNode = Val(t2)
    iStopNode = Val(t3)
    sInitAir = t4
    ReadFile = True
    Exit Function
InErr:
    ReadFile = False

End Function

Public Sub WriteData()
'
    Print #1, IStr(iID); IStr(iStartNode); IStr(iStopNode); sInitAir
    
End Sub



Property Get StartNode() As Integer
    StartNode = iStartNode
    
End Property

Property Let StartNode(iNode As Integer)
    iStartNode = iNode
    
End Property


Property Let StopNode(iNode As Integer)
    iStopNode = iNode
    
End Property


Property Get StopNode() As Integer
    StopNode = iStopNode
    
End Property

Public Sub XCopy(ssrc As cVent)
' Copy the contents of section ssrc

    With ssrc
        iStartNode = .StartNode
        iStopNode = .StopNode
        sInitAir = .InitAir
        uVShaft.XCopy .uVShaft
    End With

End Sub

Private Sub Class_Initialize()
    Set uVShaft = New cVShaft
    Set uVShaft.Daddy = Me
    uVShaft.id = iID
    
End Sub

Private Sub Class_Terminate()
    ' Delete the shaft
    Set uVShaft = Nothing
    
End Sub


