VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cVentSeg"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       cVentSeg.cls
'  This class contains Vent Segment Data
'  Objects of this class are members of a collection in
'  Vent Shaft Objects
    
Private sLength As String * 10        ' First subsegment
Private sArea As String * 10          ' Last subsegment
Private sPerim As String * 10        ' Wall Temperature
Private sFPHL As String * 10         ' Dry-bulb Temperature
Private sFNHL As String * 10         ' Wet-bulb Temperature
Private sBPHL As String * 10         ' Dry-bulb Temperature
Private sBNHL As String * 10         ' Wet-bulb Temperature

Public Sub getVSeg(sLen As String, Area As String, Perim As String, _
     FPHL As String, FNHL As String, BPHL As String, BNHL As String)
    sLen = sLength
    Area = sArea
    Perim = sPerim
    FPHL = sFPHL
    FNHL = sFNHL
    BPHL = sBPHL
    BNHL = sBNHL
    
End Sub

Public Function ReadData() As Boolean
' read values for this subsegment from the data file
Dim t1, t2, t3, t4, t5, t6, t7, t8
    ReadData = False
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sLength = t1
    sArea = t2
    sPerim = t3
    sFPHL = t4
    sFNHL = t5
    sBPHL = t6
    sBNHL = t7
    ReadData = True
    
End Function

Public Sub setVSeg(sLen As String, Area As String, Perim As String, _
     FPHL As String, FNHL As String, BPHL As String, BNHL As String)
    sLength = sLen
    sArea = Area
    sPerim = Perim
    sFPHL = FPHL
    sFNHL = FNHL
    sBPHL = BPHL
    sBNHL = BNHL
    
End Sub



Public Sub WriteData()
' Write the data for one vent segment
    Print #1, sLength; sArea; sPerim; sFPHL; sFNHL; sBPHL; sBNHL
    
End Sub

Public Sub XCopy(src As cVentSeg)
'  copy values from the argument
    src.getVSeg sLength, sArea, sPerim, sFPHL, sFNHL, sBPHL, sBNHL
    
End Sub


Private Sub Class_Initialize()
    sLength = Zero
    sArea = Zero
    sPerim = Zero
    sFPHL = Zero
    sFNHL = Zero
    sBPHL = Zero
    sBNHL = Zero
    
End Sub


