Attribute VB_Name = "modPrintFile"
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

' PrintFile Module
Const LMargin = 11
Const HMargin = 8
Private Hdr As String * 84
Private LX As Integer, RX As Integer, DY As Integer, DY4 As Integer

Public Sub PrintFile()
' Read the SES File and Print it with page breaks and headers
' Format With:
'   Date at Lower Left
'   Filename at Upper Right
'   Page Number at Lower Right
' Consider printing System Description as Line 2
'
Dim LL As String
Dim ii As Integer, ln As Integer, Bottom As Integer
    On Error Resume Next
    frmMain.MousePointer = vbHourglass
    
'   Build the header and footer
    LL = "File: " & frmMain.SESShortName
    ii = Len(LL)
    Hdr = "SES DATA FILE"
    Mid(Hdr, 84 - ii) = LL
    
' Setup Printer & Get page characteristics
    Printer.Font.Name = "Courier New" & Chr(0)
    Printer.Font.Size = 10
    ' Printer.Font.bold = False
    LX = Printer.TextWidth(Space(HMargin - 2))
    RX = Printer.TextWidth(Hdr)
    DY = Printer.TextHeight(Hdr)
    DY4 = DY / 4
    Bottom = Printer.ScaleHeight - 5 * DY
    
    ' Print the first header
    PrintHdr
    
    While Not EOF(1)
        Line Input #1, LL
        If Printer.CurrentY > Bottom Then
            PrintFtr
            Printer.NewPage
            PrintHdr
        End If
        Printer.Print Tab(LMargin); LL
    Wend
    ' Print footer on the last page
    Printer.CurrentY = Bottom
    PrintFtr
    Printer.EndDoc          ' Close the printer spool
    frmMain.MousePointer = vbDefault

End Sub

Private Sub PrintHdr()
    Printer.Print
    Printer.Print
    Printer.Font.Name = "Courier New" & Chr(0)
    Printer.Font.Size = 10
    Printer.Font.italic = False
    Printer.Font.bold = False
    Printer.Print Tab(HMargin); Hdr
    Printer.Line Step(LX, DY4)-Step(RX, 0)
    Printer.Print
    Printer.Print

End Sub

Private Sub PrintFtr()
    Printer.Print
    Printer.Print
    Printer.Line Step(LX, 0)-Step(RX, 0)
    Printer.CurrentY = Printer.CurrentY + DY4
    Printer.Print Tab(HMargin); Date; Tab(84); "Pg "; Printer.Page

End Sub
