VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SESDataSet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       SESDataSet.cls

' This class represents the entire SES input data file
' Some of the variables are direct properties and some are
' collections of other objects.

' PROPERTIES
Private sFileID As String * 80
' Form 1
Private sSysid As String * 80
Private sTitle(19) As String * 80
Private sDgnHr As String * 10
Private sDgnMon As String * 10
Private sDgnYr As String * 10
'  1C
Public iTPopt As Integer
Private iTHopt As Integer
Private iHDOpt As Integer
Private iECLOpt As Integer
Private ihsopt As Integer
Private iSupOpt As Integer
Private iSimErr As Integer
Private iInErr As Integer
'  1D   - Most of these are counted internally, not input
Private iNLS As Integer
Private iNSec As Integer
Private iNVSec As Integer
Private iNNode As Integer
Private iNBrJct As Integer
' Private iNPortl As Integer - Deleted by consensus 10/11/96
Private iNumul As Integer
Private iNFNTyp As Integer
Private iNLSec As Integer  ' No of line sections (calculated)
'  1E   - Most of these are counted internally, not input
Private iNTRRTE As Integer
Private iNTRTYP As Integer
Private iNCLUST As Integer
Private iFSCFT As Integer
Private iNTRAN As Integer
Private iNIFTYP As Integer
Private iRstRead As Integer
Private iRstWrite As Integer
Private sRstFile As String * 80
'  1F
Private sTDBAmb As String * 10
Private sTWBAmb As String * 10
Private sPAmb As String * 10
Private sTAmbA As String * 10
Private sTWAmbA As String * 10
Private sTAmbM As String * 10
Private sTWAmbE As String * 10
Private sAnnAmp As String * 10
'  1G
Private sPatWht As String * 10
Private sEfSux As String * 10
Private sEfMux As String * 10
Private sEfASux As String * 10
Private sEfAMux As String * 10
Private sUMaxUx As String * 10
Private sEECPG As String * 10
Private iFirOpt As Integer

' Form 12
Private Const MaxIntervals = 25
Private sTempTabInc As String * 10
Private iNPrintGrp As Integer
Private PGroups(MaxIntervals) As cPGroup

' Form 13
Private sDeltaT As String * 10
Private sTMax As String * 10
Private iNCTrain As Integer
Private iNCWall As Integer
'
'  The Collections . . .
'
Public Lines As cSections
Public Vents As cVents
Public Fires As cFires
Public Nodes As cNodes
Public Fans As cFans
Public Routes As cRoutes
Public Trains As cTrains
Public InitTrains As cInitTrains
Public Zones As cECZones

Public ErrForm As String        ' Holds name of input form currently being
                                ' Read in case of a read error

Public Property Let FanOpt(iOpt As Integer)
    iFSCFT = iOpt
    
End Property

Public Property Get FanOpt() As Integer
    FanOpt = iFSCFT
    
End Property
Public Property Let FireOpt(iOpt As Integer)
    iFirOpt = iOpt
    
End Property

Public Property Get FireOpt() As Integer
    FireOpt = iFirOpt
    
End Property

Public Property Get NFans() As Integer
    NFans = iNFNTyp
End Property

Public Property Get NLSec() As Integer
    NLSec = Lines.Count
    
End Property

Public Property Get NLS() As Integer
    NLS = iNLS
    
End Property

Sub AddPGroup(pg As cPGroup)
    iNPrintGrp = iNPrintGrp + 1
    Set PGroups(iNPrintGrp) = pg

End Sub

Sub ClrPGroup()
Dim i As Integer
    For i = 1 To iNPrintGrp
        Set PGroups(i) = Nothing
    Next i
    iNPrintGrp = 0
    
End Sub


Public Property Get DeltaT() As String
    DeltaT = sDeltaT
    
End Property

Public Property Let DeltaT(D As String)
    sDeltaT = D
    
End Property

Public Property Get NVSec() As Integer
    NVSec = iNVSec
    
End Property

Public Function PGroup(i As Integer) As cPGroup
    If i <= iNPrintGrp Then
        Set PGroup = PGroups(i)
    Else
        Set PGroup = Nothing
    End If
    
End Function

Public Sub ReadFile()
' Read the dataset from the file
' the file must already be open for input on unit 1
Dim sll As String * 80          ' line input buffer
Dim ii As Integer, jj As Integer
Dim t1, t2, t3, t4, t5, t6, t7, t8
' Set the vbhourglass, this may take a while
    Screen.MousePointer = vbHourglass
' Setup the progress bar
    frmMain.ProgressBar1.Visible = True
    frmMain.ProgressBar1.ZOrder 0
    frmMain.ProgressBar1.Value = 10
    frmMain.Refresh
' Get the system ID and title lines
ErrForm = "Form 1A"
    On Error GoTo ReadErr
    Line Input #1, sSysid
    For ii = 1 To 19
        Line Input #1, sll
        If (IsNumeric(Left$(sll, 10))) _
            And (IsNumeric(Mid$(sll, 11, 10))) Then
            Exit For
        End If
        sTitle(ii) = sll
    Next ii
    ' clear the rest of the title lines
    For jj = ii To 19
        sTitle(jj) = ""
    Next jj
    If ii > 19 Then Line Input #1, sll
'       Form 1B
ErrForm = "Form 1B"
    ' Get the Design Date from the record in sll
    sDgnHr = Mid$(sll, 1, 10)
    sDgnMon = Mid$(sll, 11, 10)
    sDgnYr = Mid$(sll, 21, 10)
'       Form 1C
ErrForm = "Form 1C"
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then GoTo ReadErr
    iTPopt = Val(t1)
    iTHopt = Val(t2)
    iHDOpt = Val(t3)
    iECLOpt = Val(t4)
    ihsopt = Val(t5)
    iSupOpt = Val(t6)
    iSimErr = Val(t7)
    iInErr = Val(t8)
'
'       Form 1D
ErrForm = "Form 1D"
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then GoTo ReadErr
    iNLS = Val(t1)
    iNSec = Val(t2)
    iNVSec = Val(t3)
    iNNode = Val(t4)
    iNBrJct = Val(t5)
    iNumul = Val(t7)
    iNFNTyp = Val(t8)
    iNLSec = iNSec - iNVSec
'
'       Form 1E
ErrForm = "Form 1E"
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then GoTo ReadErr
    iNTRRTE = Val(t1)
    iNTRTYP = Val(t2)
    iNCLUST = Val(t3)
    iFSCFT = Val(t4)
    iNTRAN = Val(t5)
    iNIFTYP = Val(t6)
    iRstWrite = Val(t7)
    iRstRead = Val(t8)
'
'       Form 1F
ErrForm = "Form 1F"
    If Not GetLine(sTDBAmb, sTWBAmb, sPAmb, sTAmbA, sTWAmbA, _
        sTAmbM, sTWAmbE, sAnnAmp) Then GoTo ReadErr

'       Form 1G
ErrForm = "Form 1G"
    If Not GetLine(sPatWht, sEfSux, sEfMux, sEfASux, _
        sEfAMux, sUMaxUx, t7, sEECPG) Then GoTo ReadErr
    iFirOpt = Val(t7)
'
'
    frmMain.ProgressBar1.Max = 10 + iNLS + iNSec + iNVSec + iNNode + _
         iNFNTyp + iNTRRTE * 15 + iNTRTYP * 10 + iNTRAN + iNCLUST
    ' Have the line & vent collections Read the line sections
    ' Form 2A
ErrForm = "Form 2A"
    If Not Lines.ReadSections(iNLSec) Then GoTo ReadErr
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNLSec
    ' Form 2B
ErrForm = "Form 2B"
    If Not Vents.ReadVents(iNVSec) Then GoTo ReadErr
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNVSec
    ' Form 3
 ErrForm = "Form 3"
    If Not Lines.ReadSegments Then GoTo ReadErr
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNLS
    ' Form 4
ErrForm = "Form 4"
    If iNumul > 0 Then
        If Not Fires.ReadFires(iNumul) Then GoTo ReadErr
    End If
    ' Form 5
ErrForm = "Form 5"
    If Not Vents.ReadVShafts Then GoTo ReadErr
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNVSec
    ' Form 6
ErrForm = "Form 6"
    If Not Nodes.ReadNodes(iNNode) Then GoTo ReadErr
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNNode
'       frmMain.Refresh
    ' Form 7
ErrForm = "Form 7"
    If Not Fans.ReadFans(iNFNTyp, iNIFTYP) Then GoTo ReadErr
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNFNTyp
 '   frmMain.Refresh
    
    If TPOpt > 0 Then
        ' Form 8
ErrForm = "Form 8"
        If Not Routes.ReadRoutes(iNTRRTE) Then GoTo ReadErr
        frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNTRRTE * 15
        ' Form 9
ErrForm = "Form 9"
        If Not Trains.ReadTrains(iNTRTYP) Then GoTo ReadErr
        frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNTRTYP * 10
        ' Form 10
ErrForm = "Form 10"
        If Not InitTrains.ReadITrains(iNTRAN) Then GoTo ReadErr
        frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNTRAN
    End If
    ' Form 11
    If iECLOpt > 0 Then
ErrForm = "Form 11"
        If Not Zones.ReadECZones(iNCLUST) Then GoTo ReadErr
        frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNCLUST
    End If
    ' Form 12
ErrForm = "Form 12"
    If Not GetFour(sTempTabInc, t2, t3, t4) Then GoTo ReadErr
    iNPrintGrp = Val(t2)
    For ii = 1 To iNPrintGrp
        If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then GoTo ReadErr
        Set PGroups(ii) = New cPGroup
        PGroups(ii).setPGroup Val(t1), Str(t2), Val(t3), _
           Val(t4), Val(t5), Val(t6)
    Next ii
    
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Max
    ' Form 13
ErrForm = "Form 13"
    If Not GetFour(sDeltaT, sTMax, t3, t4) Then GoTo ReadErr
    iNCTrain = Val(t3)
    iNCWall = Val(t4)
'
' Get restart file name, if required
    If iRstRead > 0 Then Line Input #1, sRstFile
    
    ' Reset the Mouse Pointer
    Screen.MousePointer = vbDefault
    frmMain.ProgressBar1.Visible = False
    Exit Sub
    
    '   Error Reading File
ReadErr:
    Screen.MousePointer = vbDefault
    frmMain.ProgressBar1.Visible = False
    MsgBox "Error Reading " & ErrForm & vbCrLf & "In File " & frmMain.SESShortName, _
        16, "Open Data File"
    
    Exit Sub
    
End Sub

Public Property Let Sysid(ss As String)
' Trim the string to the proper length and store it
    sSysid = Left$(ss, 80)
End Property
Public Property Let TempTabInc(AA As String)
    sTempTabInc = AA
End Property

Public Property Let Title(ss As String)
' Divide the string from the multiline textbox into
' _Not_More_Than_ 19 separate lines, separated at word
' boundaries if there aren't adequate line feeds.
Dim ii As Integer, jj As Integer, LL As Integer, kk As Integer
Dim lls As Integer
    jj = 1
    lls = Len(ss)
    If lls = 0 Then
        ss = " "
        lls = 1
    End If
    For ii = 1 To 19
        kk = InStr(jj, ss, vbCrLf)
        LL = lls + 1
        If kk > 0 And kk < LL Then LL = kk
        If (LL - jj <= 80) Then
            sTitle(ii) = Mid$(ss, jj, LL - jj)
            jj = LL + 2
        Else
            For kk = jj + 80 To jj Step -1
                If Mid$(ss, kk, 1) = " " Then Exit For
            Next kk
            sTitle(ii) = Mid$(ss, jj, kk - jj)
            jj = kk + 1
        End If
        If jj >= Len(ss) Then Exit For
    Next ii
    ' Clear the remainder of the string
    For jj = ii + 1 To 19
        sTitle(jj) = Empty
    Next jj
End Property

Public Property Get Title() As String
' convert the 19 lines of title for a multiline textbox
Dim ii As Integer
Dim ttitle As String
    ttitle = RTrim$(sTitle(1))
    For ii = 2 To 19
        If Trim$(sTitle(ii)) = "" Then
            Exit For
        Else
            ttitle = ttitle & Chr$(13) & Chr(10) & RTrim$(sTitle(ii))
        End If
    Next ii
    Title = ttitle
End Property

Public Property Get Sysid() As String
    Sysid = sSysid
End Property

Public Property Let DgnHr(ss As String)
    sDgnHr = ss
End Property
Public Property Get DgnHr() As String
    DgnHr = sDgnHr
End Property

Public Property Let DgnYr(ss As String)
    sDgnYr = ss
End Property
Public Property Get DgnYr() As String
    DgnYr = sDgnYr
End Property

Public Property Let DgnMon(ss As String)
    sDgnMon = ss
End Property
Public Property Get DgnMon() As String
    DgnMon = sDgnMon
End Property

Public Property Let TPOpt(ii As Integer)
    iTPopt = ii
End Property
Public Property Get TPOpt() As Integer
    TPOpt = iTPopt
End Property

Public Property Let RstRead(ii As Integer)
    iRstRead = ii
End Property
Public Property Get RstRead() As Integer
    RstRead = iRstRead
End Property

Public Property Let RstFileName(RName As String)
    sRstFile = RName
End Property
Public Property Get RstFileName() As String
    RstFileName = sRstFile
End Property

Public Property Let RstWrite(ii As Integer)
    iRstWrite = ii
End Property
Public Property Get RstWrite() As Integer
    RstWrite = iRstWrite
End Property

Public Property Let THOpt(ii As Integer)
    iTHopt = ii
End Property
Public Property Get THOpt() As Integer
    THOpt = iTHopt
End Property

Public Property Let HDOpt(ii As Integer)
    iHDOpt = ii
End Property
Public Property Get HDOpt() As Integer
    HDOpt = iHDOpt
End Property

Public Property Let ECLOpt(ii As Integer)
    iECLOpt = ii
End Property
Public Property Get ECLOpt() As Integer
    ECLOpt = iECLOpt
End Property

Public Property Let HSOpt(ii As Integer)
    ihsopt = ii
End Property
Public Property Get HSOpt() As Integer
    HSOpt = ihsopt
End Property

Public Property Let SupOpt(ii As Integer)
    iSupOpt = ii
End Property
Public Property Get SupOpt() As Integer
    SupOpt = iSupOpt
End Property

Public Property Let SimErr(ii As Integer)
    iSimErr = ii
End Property
Public Property Get SimErr() As Integer
    SimErr = iSimErr
End Property

Public Property Let InErr(ii As Integer)
    iInErr = ii
End Property
Public Property Get InErr() As Integer
    InErr = iInErr
End Property

Public Property Let TDBAmb(ss As String)
    sTDBAmb = ss
End Property
Public Property Get TDBAmb() As String
    TDBAmb = sTDBAmb
End Property

Public Property Let TWBAmb(ss As String)
    sTWBAmb = ss
End Property
Public Property Get TWBAmb() As String
    TWBAmb = sTWBAmb
End Property

Public Property Let PAmb(ss As String)
    sPAmb = ss
End Property
Public Property Get PAmb() As String
    PAmb = sPAmb
End Property

Public Property Let TAmbA(ss As String)
    sTAmbA = ss
End Property
Public Property Get TAmbA() As String
    TAmbA = sTAmbA
End Property

Public Property Let TWAmbA(ss As String)
    sTWAmbA = ss
End Property
Public Property Get TWAmbA() As String
    TWAmbA = sTWAmbA
End Property

Public Property Let TAmbM(ss As String)
    sTAmbM = ss
End Property
Public Property Get TAmbM() As String
    TAmbM = sTAmbM
End Property

Public Property Let TWAmbE(ss As String)
    sTWAmbE = ss
End Property
Public Property Get TWAmbE() As String
    TWAmbE = sTWAmbE
End Property

Public Property Let TAnnAmp(ss As String)
    sAnnAmp = ss
End Property


Public Property Get TAnnAmp() As String
    TAnnAmp = sAnnAmp
End Property

Public Property Let EFSux(ss As String)
    sEfSux = ss
End Property
Public Property Get EFSux() As String
    EFSux = sEfSux
End Property

Public Property Let EFMux(ss As String)
    sEfMux = ss
End Property
Public Property Get EFMux() As String
    EFMux = sEfMux
End Property

Public Property Let EFASux(ss As String)
    sEfASux = ss
End Property
Public Property Get EFASux() As String
    EFASux = sEfASux
End Property

Public Property Let EFAMux(ss As String)
    sEfAMux = ss
End Property
Public Property Get EFAMux() As String
    EFAMux = sEfAMux
End Property

Public Property Let UMaxUx(ss As String)
    sUMaxUx = ss
End Property
Public Property Get UMaxUx() As String
    UMaxUx = sUMaxUx
End Property

Public Property Let PatWht(ss As String)
    sPatWht = ss
End Property
Public Property Get PatWht() As String
    PatWht = sPatWht
End Property

Public Property Let EECPG(ss As String)
    sEECPG = ss
End Property
Public Property Get EECPG() As String
    EECPG = sEECPG
End Property

Public Property Let NCTrain(ii As Integer)
    iNCTrain = ii
End Property
Public Property Get NCTrain() As Integer
    NCTrain = iNCTrain
End Property

Public Property Let NCWall(ii As Integer)
    iNCWall = ii
End Property

Public Property Get NCWall() As Integer
    NCWall = iNCWall
End Property


Public Property Get NPGroups() As Integer
    NPGroups = iNPrintGrp
    
End Property

Public Property Let TMax(ii As String)
    sTMax = ii
End Property
Public Property Get TMax() As String
    TMax = sTMax
End Property


Public Property Get TempTabInc() As String
    TempTabInc = sTempTabInc
    
End Property
Public Sub getCounts(nnls, nnlsec, nnvsec, nnnode, nnumul, _
    nnfntyp, nniftyp, nntrrte, nntrtyp, nnclust, nntrain)
Dim colsegs As New Collection
    Lines.SegCol colsegs

    nnls = colsegs.Count
    nnlsec = Lines.Count
    nnvsec = Vents.Count
    nnnode = Nodes.Count
    nnumul = Fires.Count
    nnfntyp = Fans.Count
    nniftyp = Fans.ICount
    nntrrte = IIf(iTPopt > 0, Routes.Count, 0)
    nntrtyp = IIf(iTPopt > 0, Trains.Count, 0)
    nnclust = IIf(iECLOpt > 0, Zones.Count, 0)
    nntrain = IIf(iTPopt > 0, InitTrains.Count, 0)
    
End Sub
Public Sub WriteFile()
' Write the data set
Dim ii As Integer, ss As String
Dim Seg As cSegment, colsegs As New Collection
'  All other forms should already be closed
' Set the vbhourglass, this may take a while
    Screen.MousePointer = vbHourglass
'  Update data counters
    Lines.SegCol colsegs
    iNLS = colsegs.Count
    iNLSec = Lines.Count
    iNVSec = Vents.Count
    iNSec = iNLSec + iNVSec
    iNNode = Nodes.Count
    iNBrJct = Nodes.BrCount
    iNumul = Fires.Count
    iNFNTyp = Fans.Count
    iNIFTYP = Fans.ICount
    iNTRRTE = IIf(iTPopt > 0, Routes.Count, 0)
    iNTRTYP = IIf(iTPopt > 0, Trains.Count, 0)
    iNCLUST = IIf(iECLOpt > 0, Zones.Count, 0)
    iNTRAN = IIf(iTPopt > 0, InitTrains.Count, 0)
' Set up the progress bar
    frmMain.ProgressBar1.Visible = True
    frmMain.ProgressBar1.ZOrder 0
    frmMain.ProgressBar1.Value = 10
    frmMain.Refresh
    frmMain.ProgressBar1.Max = 10 + iNLS + iNSec + iNVSec + iNNode + _
         iNFNTyp + iNTRRTE * 15 + iNTRTYP * 10 + iNTRAN + iNCLUST
    
'  Write the titles
    Print #1, sSysid
    For ii = 1 To 19
        ss = RTrim(sTitle(ii))
        If ss <> "" Then Print #1, ss
    Next ii
    ' Now the rest of Form 1's
    Print #1, sDgnHr; sDgnMon; sDgnYr
    Print #1, IStr(iTPopt); IStr(iTHopt); IStr(iHDOpt); IStr(iECLOpt); _
            IStr(ihsopt); IStr(iSupOpt); IStr(iSimErr); IStr(iInErr)
    Print #1, IStr(iNLS); IStr(iNSec); IStr(iNVSec); IStr(iNNode); _
            IStr(iNBrJct); Spc(10); IStr(iNumul); IStr(iNFNTyp)
    Print #1, IStr(iNTRRTE); IStr(iNTRTYP); IStr(iNCLUST); IStr(iFSCFT); _
            IStr(iNTRAN); IStr(iNIFTYP); IStr(iRstWrite); IStr(iRstRead)
    Print #1, sTDBAmb; sTWBAmb; sPAmb; sTAmbA; sTWAmbA; sTAmbM; sTWAmbE; sAnnAmp
    Print #1, sPatWht; sEfSux; sEfMux; sEfASux; sEfAMux; sUMaxUx; IStr(iFirOpt); sEECPG

' Now tell the collections to write them selves
    ' Form 2
    Lines.WriteSections
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNLSec
    Vents.WriteVents
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNVSec
    ' Form 3
    '  Use the segment collection built when counting
    For Each Seg In colsegs
        Seg.WriteData
    Next
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNLS
    ' Form 4
    Fires.WriteFires
    ' Form 5
    Vents.WriteVShafts
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNVSec
    ' Form 6
    Nodes.WriteNodes
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNNode
    ' Form 7
    Fans.WriteFans
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNFNTyp
    
    ' Route & Train Data
    If iTPopt > 0 Then
        ' Form 8
        Routes.WriteRoutes
        frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNTRRTE * 15
        ' Form 9
        Trains.WriteTrains
        frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNTRTYP * 10
        ' Form 10
        InitTrains.WriteITrains
        frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNTRAN
    End If
    ' Form 11
    If iECLOpt > 0 Then
        Zones.WriteECZones
        frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + iNCLUST
    End If
    ' Form 12 - Print Groups
    Print #1, sTempTabInc; IStr(iNPrintGrp)
    For ii = 1 To iNPrintGrp
        PGroups(ii).WriteData
    Next ii
    '
    
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Max
    ' Form 13 - Execution Control Data
    Print #1, sDeltaT; sTMax; IStr(iNCTrain); IStr(iNCWall)
    ' Restart Filename
    If iRstRead > 0 Then
        Print #1, sRstFile
    End If
    ' Reset the Mouse Pointer
    Screen.MousePointer = vbDefault
    frmMain.ProgressBar1.Visible = False
    
End Sub

' METHODS
Private Sub Class_Initialize()
Dim ii As Integer
' Set vbhourglass, this may take a minute
    Screen.MousePointer = vbHourglass
' Set default values for all variables
    sSysid = " "
    For ii = 1 To 19
        sTitle(ii) = " "
    Next ii
    sDgnHr = "12."
    sDgnMon = "7."
    sDgnYr = "1997."
    iTPopt = 0
    iTHopt = 0
    iHDOpt = 1
    iECLOpt = 0
    ihsopt = 0
    iSupOpt = 0
    iSimErr = 0
    iInErr = 0
    
    iNLS = 0
    iNSec = 1
    iNVSec = 0
    iNLSec = 0
    iNNode = 2
    iNBrJct = 0
    iNumul = 0
    iNFNTyp = 0
    iNTRRTE = 0
    iNTRTYP = 0
    iNCLUST = 0
    iFSCFT = 2
    iNTRAN = 0
    iNIFTYP = 0
    iRstRead = 0
    iRstWrite = 0
    sRstFile = ""
    sTDBAmb = Zero
    sTWBAmb = Zero
    sPAmb = Zero
    sTAmbA = Zero
    sTWAmbA = Zero
    sTAmbM = Zero
    sTWAmbE = Zero
    sAnnAmp = Zero
    sPatWht = "100."
    sEfSux = Zero
    sEfMux = Zero
    sEfASux = Zero
    sEfAMux = Zero
    sUMaxUx = Zero
    sEECPG = Zero
    iFirOpt = 0
'
'   Forms 12 & 13
'
    iNCTrain = 5
    iNCWall = 5
    sTMax = "120."
    sDeltaT = "10."
    sTempTabInc = "10."
'
' Initialize collections
    Set Lines = New cSections
    Set Vents = New cVents
    Set Fires = New cFires
    Set Nodes = New cNodes
    Set Fans = New cFans
    Set Routes = New cRoutes
    Set Trains = New cTrains
    Set InitTrains = New cInitTrains
    Set Zones = New cECZones
    
' Restore screen pointer
    Screen.MousePointer = 0    'Default

End Sub


Private Sub Class_Terminate()
Dim ii As Integer
' Empty all the Collection
    For ii = 1 To Lines.Count
        Lines.Delete 1
    Next ii
    Set Lines = Nothing
    
    For ii = 1 To Vents.Count
        Vents.Delete 1
    Next ii
    Set Vents = Nothing
    
    For ii = 1 To Fires.Count
        Fires.Delete 1
    Next ii
    Set Fires = Nothing
    
    For ii = 1 To Nodes.Count
        Nodes.Delete 1
    Next ii
    Set Nodes = Nothing
    
    For ii = 1 To Fans.Count
        Fans.Delete 1
    Next ii
    Set Fans = Nothing
    
    For ii = 1 To Routes.Count
        Routes.Delete 1
    Next ii
    Set Routes = Nothing
    
    For ii = 1 To Trains.Count
        Trains.Delete 1
    Next ii
    Set Trains = Nothing
    
    For ii = 1 To InitTrains.Count
        InitTrains.Delete 1
    Next ii
    Set InitTrains = Nothing
    
    For ii = 1 To Zones.Count
        Zones.Delete 1
    Next ii
    Set Zones = Nothing
    
   
End Sub


