VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cECZone"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan 1997

Option Explicit

'  class cECZone.cls
'
'  This class is for a single Environmental Control Zone
'

Private iECZType As Integer
Private iNSeg As Integer
Private sEZMTWB As String * 10
Private sEZMTDB As String * 10
Private sEZETWB As String * 10
Private sEZETDB As String * 10
Private colZSegs As New Collection

Public Property Get NSegs()
    NSegs = colZSegs.Count
    
End Property

Public Sub getZone(nType As Integer, _
    s1 As String, s2 As String, s3 As String, s4 As String)
    nType = iECZType
    s1 = sEZMTWB
    s2 = sEZMTDB
    s3 = sEZETWB
    s4 = sEZETDB
    
End Sub

Public Sub setZone(nType As Integer, _
    s1 As String, s2 As String, s3 As String, s4 As String)
    iECZType = nType
    sEZMTWB = s1
    sEZMTDB = s2
    sEZETWB = s3
    sEZETDB = s4
    
End Sub

Public Sub ZSectList(LL As ListBox, CC As Collection)
'  Load the Route Section List into LL
Dim sid, sss As String
    LL.Clear
    For Each sid In colZSegs
        sss = Str$(sid)
        LL.AddItem CC(sss).sid
    Next
    
End Sub

Public Sub ZSectSave(LL As ListBox)
' Save the Zone Section list from the Listbox LL
Dim sid As Integer, ii As Integer
On Error Resume Next
    ' clear the collection
    For ii = 1 To colZSegs.Count
        colZSegs.Remove 1
    Next ii
    
    For ii = 0 To LL.ListCount - 1
        colZSegs.Add Str(Val(LL.List(ii)))
    Next ii
End Sub

Public Sub ZSectStrip(CC As Collection)
' Mark segments in CC that are used in this zone
Dim jj As Integer, nn As Integer
Dim ss As String
    nn = colZSegs.Count
    For jj = 1 To nn
        ss = Str$(colZSegs.Item(jj))
        CC(ss).used = True
    Next jj
    
End Sub

Public Function ReadData(nn As Integer) As Boolean
' nn is the total number of EC Zones
' if nn is one, don't read segment list
Dim LL$
Dim t1, t2, t3, t4, t5, t6, t7, t8
Dim ii As Integer, mm As Integer
' Read the Data for ONE Environmental Control Zone
    ReadData = False
    On Error GoTo InErr
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    iECZType = Val(t1)
    iNSeg = Val(t2)
    sEZMTWB = t3
    sEZMTDB = t4
    sEZETWB = t5
    sEZETDB = t6
    If nn > 1 Then
       For ii = 0 To iNSeg - 1
            mm = (ii Mod 8)
            If (mm = 0) Then Line Input #1, LL$
            colZSegs.Add Trim(Mid$(LL$, mm * 10 + 1, 10))
        Next ii
    End If
    ReadData = True
    Exit Function
InErr:
    ReadData = False
    
End Function

Public Sub WriteData()
Dim ss, ii As Integer, nn As Integer, LL As String * 80
    Print #1, IStr(iECZType); IStr(colZSegs.Count); _
        sEZMTWB; sEZMTDB; sEZETWB; sEZETDB
            
    ii = 1
    LL = ""
    For Each ss In colZSegs
        Mid$(LL, (ii - 1) * 10 + 1, 10) = IStr(Val(ss))
        If ii > 7 Then
            Print #1, LL
            ii = 1
            LL = ""
        Else
            ii = ii + 1
        End If
    Next ss
    If ii > 1 Then Print #1, LL
End Sub

Public Sub XCopy(EZ As cECZone)
Dim ii As Integer
    EZ.getZone iECZType, sEZMTWB, sEZMTDB, sEZETWB, sEZETDB
    For ii = 1 To colZSegs.Count  ' clear any existing sections
        colZSegs.Remove 1
    Next ii
'  Don't copy sections or we will have duplicates
End Sub

Private Sub Class_Initialize()
    iECZType = 1
    iNSeg = 0
    sEZMTWB = Zero
    sEZMTDB = Zero
    sEZETWB = Zero
    sEZETDB = Zero
    
End Sub

Private Sub Class_Terminate()
Dim ii As Integer
    For ii = 1 To colZSegs.Count
        colZSegs.Remove 1
    Next ii
End Sub
