VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cECZones"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan 1997

Option Explicit

'  class cECZones.cls
'
'  This is the collection management class for
'  Environmental Control Zone Data

Private colECZones As Collection
Private bufferECZone As cECZone

Public Function Add(indx As Integer) As cECZone
Dim zz As New cECZone
    If indx = 0 Then
        colECZones.Add zz
    Else
        colECZones.Add zz, before:=indx
    End If
    Set Add = zz
    
End Function

Public Property Get Zone(indx As Integer) As cECZone
    Set Zone = colECZones(indx)
    
End Property

Public Property Get Count() As Integer
    Count = colECZones.Count
    
End Property

Public Sub Copy(ii As Integer)
' Copy ECZone ii to buffer
    Set bufferECZone = New cECZone
    bufferECZone.XCopy colECZones(ii)
    
End Sub

Public Sub Paste(ii As Integer)
' Paste the contents of the buffer to the list at ii
Dim ff As cECZone
    Set ff = New cECZone
    ff.XCopy bufferECZone
    colECZones.Add ff, before:=ii
    
End Sub

Public Sub Delete(indx As Integer)
    colECZones.Remove indx
    
End Sub

Public Function ReadECZones(nn As Integer) As Boolean
Dim ii As Integer
Dim Zone As cECZone
    ReadECZones = False
    For ii = 1 To nn
        Set Zone = New cECZone
        If Not Zone.ReadData(nn) Then Exit Function
        colECZones.Add Zone
    Next ii
    ReadECZones = True
    
End Function

Public Sub WriteECZones()
Dim ii As Integer, nnls As Integer, nnlsec As Integer, nnvsec As Integer
Dim nnnode As Integer, nnumul As Integer
Dim nnfntyp As Integer, nniftyp As Integer, nntrrte As Integer
Dim nntrtyp As Integer, nnclust As Integer, nntrain As Integer
Dim za As String, zb As String, zc As String, zd As String
    If colECZones.Count = 1 Then
        colECZones(1).getZone ii, za, zb, zc, zd
        SESDS.getCounts nnls, nnlsec, nnvsec, nnnode, nnumul, _
    nnfntyp, nniftyp, nntrrte, nntrtyp, nnclust, nntrain
        Print #1, IStr(ii); IStr(nnls + nnvsec); za; zb; zc; zd
    Else
        For ii = 1 To colECZones.Count
            colECZones(ii).WriteData
        Next ii
    End If
End Sub

Private Sub Class_Initialize()
    Set colECZones = New Collection
    
End Sub

Private Sub Class_Terminate()
Dim ii As Integer
    For ii = 1 To colECZones.Count
        colECZones.Remove 1
    Next ii
    Set bufferECZone = Nothing
    
End Sub
