VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cFan"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan 1997

Option Explicit

'  class cFan.cls
'
'  This class is for a single fan type
'

Private sFanId As String * 36
Private sRhoAir As String * 10
Private sRunUp As String * 10
Private sLowCFM As String * 10
Private sHiCFM As String * 10
Private sFanP(8) As String * 10
Private sFanQ(8) As String * 10

Public Property Get id() As String
    id = sFanId
    
End Property

Public Sub getFan(id As String, rho As String, runup As String, _
    QLow As String, QHi As String, FanP() As String, FanQ() As String)
Dim ii As Integer
    id = sFanId
    rho = sRhoAir
    runup = sRunUp
    QLow = sLowCFM
    QHi = sHiCFM
    For ii = 1 To 8
        FanP(ii) = sFanP(ii)
        FanQ(ii) = sFanQ(ii)
    Next ii
    
End Sub

Public Sub setFan(id As String, rho As String, runup As String, _
    QLow As String, QHi As String, FanP() As String, FanQ() As String)
Dim ii As Integer
    sFanId = id
    sRhoAir = rho
    sRunUp = runup
    sLowCFM = QLow
    sHiCFM = QHi
    For ii = 1 To 8
        sFanP(ii) = FanP(ii)
        sFanQ(ii) = FanQ(ii)
    Next ii
    
End Sub


Public Function ReadData() As Boolean
Dim LL$
Dim t1, t2, t3, t4, t5, t6, t7, t8
' Read the Data for ONE Fan
    On Error GoTo InErr
    ReadData = False
        Line Input #1, LL$
    sFanId = Left$(LL$, 36)
    sRhoAir = Mid$(LL$, 41, 10)
    sRunUp = Mid$(LL$, 51, 10)
    sLowCFM = Mid$(LL$, 61, 10)
    sHiCFM = Mid$(LL$, 71, 10)
    ' the first 4 are for exhaust
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sFanP(1) = t1
    sFanQ(1) = t2
    sFanP(2) = t3
    sFanQ(2) = t4
    sFanP(3) = t5
    sFanQ(3) = t6
    sFanP(4) = t7
    sFanQ(4) = t8
    ' the next 4 are for supply
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sFanP(5) = t1
    sFanQ(5) = t2
    sFanP(6) = t3
    sFanQ(6) = t4
    sFanP(7) = t5
    sFanQ(7) = t6
    sFanP(8) = t7
    sFanQ(8) = t8
    ReadData = True
    Exit Function
InErr:
    ReadData = False
End Function

Public Sub WriteData()
' Write the data for one Supply/Exhaust Fan
Dim ii As Integer, jj As Integer
    Print #1, sFanId; Tab(41); sRhoAir; sRunUp; sLowCFM; sHiCFM
    For jj = 1 To 5 Step 4
        For ii = jj To jj + 3
            Print #1, sFanP(ii); sFanQ(ii);
        Next ii
        Print #1,
    Next jj
   
End Sub


Public Sub XCopy(ff As cFan)
' copy the contents of fan ff
Dim fp(8) As String, fq(8) As String
Dim ii As Integer
    ff.getFan sFanId, sRhoAir, sRunUp, sLowCFM, _
        sHiCFM, fp, fq
    For ii = 1 To 8
        sFanP(ii) = fp(ii)
        sFanQ(ii) = fq(ii)
    Next ii
End Sub


Private Sub Class_Initialize()
Dim ii As Integer
    sFanId = " "
    sRhoAir = "0."
    sRunUp = "0."
    sLowCFM = "0."
    sHiCFM = "0."
    For ii = 1 To 8
        sFanP(ii) = "0."
        sFanQ(ii) = "0."
    Next ii
End Sub


