VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cFans"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan 1997

Option Explicit

'  class cFans.cls
'
'  This is the collection management class for fan data
'  One collection and one Buffer is kept for Supply/Exhaust
'   fans and one each for impulse fans

Private colFans As Collection
Private BufferFan As cFan
Private colIFans As Collection
Private BufferIFan As cIFan

Public Function Add(ii As Integer) As cFan
Dim ff As cFan
    Set ff = New cFan   ' default values set in initialize
    If ii = 0 Then
        colFans.Add ff
    Else
        colFans.Add ff, before:=ii
    End If
    Set Add = ff
    
End Function

Public Function AddI(ii As Integer) As cIFan
Dim ff As cIFan
    Set ff = New cIFan   ' default values set in initialize
    If ii = 0 Then
        colIFans.Add ff
    Else
        colIFans.Add ff, before:=ii
    End If
    Set AddI = ff
    
End Function


Public Sub Copy(ii As Integer)
' Copy fan ii to buffer
    Set BufferFan = New cFan
    BufferFan.XCopy colFans(ii)
    
End Sub

Public Sub Cut(ii As Integer)
' Copy fan ii to buffer
    Set BufferFan = New cFan
    BufferFan.XCopy colFans(ii)
    colFans.Remove ii
    
End Sub

Public Sub CopyI(ii As Integer)
' Copy fan ii to buffer
    Set BufferIFan = New cIFan
    BufferIFan.XCopy colIFans(ii)
    
End Sub

Public Sub CutI(ii As Integer)
' Copy fan ii to buffer
    Set BufferIFan = New cIFan
    BufferIFan.XCopy colIFans(ii)
    colIFans.Remove ii
    
End Sub


Public Property Get Count() As Integer
    Count = colFans.Count

End Property

Public Sub Delete(indx As Integer)
    If indx <= colFans.Count Then colFans.Remove indx
    
End Sub

Public Sub DeleteI(indx As Integer)
    colIFans.Remove indx
    
End Sub


Public Property Get Fan(ii As Integer) As cFan
    If ii <= colFans.Count Then
        Set Fan = colFans(ii)
    Else
        Set Fan = Nothing
    End If
    
End Property

Public Property Get IFan(ii As Integer) As cIFan
    If ii <= colIFans.Count Then
        Set IFan = colIFans(ii)
    Else
        Set IFan = Nothing
    End If

End Property


Public Property Get ICount() As Integer
' Return the  number of impulse fans
    ICount = colIFans.Count

End Property

Public Sub Paste(ii As Integer)
' Paste the contents of the buffer to the list at ii
Dim ff As cFan
    Set ff = New cFan
    ff.XCopy BufferFan
    colFans.Add ff, before:=ii
    
End Sub

Public Sub PasteI(ii As Integer)
' Paste the contents of the buffer to the list at ii
Dim ff As cIFan
    Set ff = New cIFan
    ff.XCopy BufferIFan
    colIFans.Add ff, before:=ii
    
End Sub

Public Sub List(cc As ComboBox)
' load the fans into the combobox for the Shaft Screen
Dim ii As Integer
    cc.Clear
    cc.AddItem "0. None"
    For ii = 1 To SESDS.Fans.Count
        cc.AddItem Format(ii) & ". " & RTrim$(SESDS.Fans.Fan(ii).id)
    Next ii

End Sub

Public Function ReadFans(nn As Integer, ni As Integer) As Boolean
Dim ii As Integer
Dim Fan As cFan, IFan As cIFan
    On Error GoTo ReadError
    ReadFans = False
    ' read supply/exhaust fans
    For ii = 1 To nn
        Set Fan = New cFan
        If Not Fan.ReadData Then Exit Function
        colFans.Add Fan
    Next ii
    ' read impulse fans
    For ii = 1 To ni
        Set IFan = New cIFan
        If Not IFan.ReadData Then Exit Function
        colIFans.Add IFan
    Next ii
    ReadFans = True
ReadError:
End Function

Public Sub WriteFans()
Dim ii As Integer
    For ii = 1 To colFans.Count
        colFans(ii).WriteData
    Next ii
    For ii = 1 To colIFans.Count
        colIFans(ii).WriteData
    Next ii

End Sub


Private Sub Class_Initialize()
    Set colFans = New Collection
    Set colIFans = New Collection
    
End Sub

