VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cFire"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       SESDataSet.cls
'
Private sid As String * 30
Private iseg As Integer
Private isubseg As Integer
Private sHSens As String * 10
Private sHLatent As String * 10
Private sTStart As String * 10
Private sTStop As String * 10
Private sTFlame As String * 10
Private sArea As String * 10

Public Property Let id(ss As String)
    sid = ss
    
End Property
Public Property Get id() As String
    id = sid
    
End Property
Public Sub SetFire(FID As String, ixseg As Integer, ixsub As Integer, _
    HSens As String, HLatent As String, _
    TStart As String, TStop As String, _
    TFlame As String, Area As String)
' Gets Fire Parameters
    sid = FID
    iseg = ixseg
    isubseg = ixsub
    sHSens = HSens
    sHLatent = HLatent
    sTStart = TStart
    sTStop = TStop
    sTFlame = TFlame
    sArea = Area

End Sub

Public Sub GetFire(FID As String, ixseg As Integer, ixsub As Integer, _
    HSens As String, HLatent As String, _
    TStart As String, TStop As String, _
    TFlame As String, Area As String)
' Gets Fire Parameters
    FID = sid
    ixseg = iseg
    ixsub = isubseg
    HSens = sHSens
    HLatent = sHLatent
    TStart = sTStart
    TStop = sTStop
    TFlame = sTFlame
    Area = sArea
    
End Sub


Public Function ReadData() As Boolean
' Reads the data for this fire from the input file
Dim LL$
Dim t1, t2, t3, t4, t5, t6, t7, t8
    ReadData = False
    On Error GoTo InErr
    Line Input #1, LL$
    sid = Left$(LL$, 36)
    iseg = Val(Mid$(LL$, 41, 10))
    isubseg = Val(Mid$(LL$, 51, 10))

    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sHSens = t1
    sHLatent = t2
    sTStart = t3
    sTStop = t4
    sTFlame = t5
    sArea = t6
    ReadData = True
    Exit Function
InErr:
    ReadData = False
End Function

Public Sub WriteData()
' Write the data for one fire
    Print #1, sid; Tab(41); IStr(iseg); IStr(isubseg)
    Print #1, sHSens; sHLatent; sTStart; sTStop; sTFlame; sArea
    
End Sub

Public Sub XCopy(ff As cFire)
' Copy the data from ff
    ff.GetFire sid, iseg, isubseg, sHSens, sHLatent, _
        sTStart, sTStop, sTFlame, sArea
        
End Sub


Private Sub Class_Initialize()
    sid = "New"
    iseg = 0
    isubseg = 0
    sHSens = "0."
    sHLatent = "0."
    sTStart = "0."
    sTStop = "0."
    sTFlame = "0."
    sArea = "0."
    
End Sub

