VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cFlyWheel"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'   Class cFlyWheel

' This class contains FlyWheel Data
' One cFlyWheel object is included in a cTrain object
' if (and only if) FlyWheel Data is required
'
Private sFWi As String * 10      ' Moment of Inertia
Private iFWn As Integer         ' Number / Car
Private iFWVMax As Integer      ' Max RPM
Private iFWVMin As Integer      ' Min RPM
Private iFWV0 As Integer        ' Initial RPM
Private sFWEffTF As String * 10 ' Eff Train-> FW
Private sFWEffFT As String * 10 ' Eff FW -> Train
Private sFWLA As String * 10    ' Inertial Loss Eq Coeff's
Private sFWLB As String * 10
Private sFWLC As String * 10
Private sFWLD As String * 10
Private sFWLE As String * 10

Public Sub getFlyWheel(ss() As String)
    ss(1) = sFWi
    ss(0) = Str(iFWn)
    ss(3) = Str(iFWVMax)
    ss(2) = Str(iFWVMin)
    ss(4) = Str(iFWV0)
    ss(5) = sFWEffTF
    ss(6) = sFWEffFT
    ss(7) = sFWLA
    ss(8) = sFWLB
    ss(9) = sFWLC
    ss(10) = sFWLD
    ss(11) = sFWLE
    
End Sub

Public Sub setFlyWheel(ss() As String)
On Error Resume Next
    sFWi = ss(1)
    iFWn = Val(ss(0))
    iFWVMax = Val(ss(3))
    iFWVMin = Val(ss(2))
    iFWV0 = Val(ss(4))
    sFWEffTF = ss(5)
    sFWEffFT = ss(6)
    sFWLA = ss(7)
    sFWLB = ss(8)
    sFWLC = ss(9)
    sFWLD = ss(10)
    sFWLE = ss(11)
    
End Sub

Public Function ReadData() As Boolean
Dim t1, t2, t3, t4, t5, t6, t7, t8
'       Form 9  - Flywheel Data
    ReadData = False
    '  9K
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sFWi = t1
    iFWn = Val(t2)
    iFWVMax = Val(t3)
    iFWVMin = Val(t4)
    iFWV0 = Val(t5)
    '  9L
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sFWEffTF = t1
    sFWEffFT = t2
    sFWLA = t3
    sFWLB = t4
    sFWLC = t5
    sFWLD = t6
    sFWLE = t7
    ReadData = True
    
End Function


Public Sub WriteData()
    Print #1, sFWi; IStr(iFWn); IStr(iFWVMax); _
        IStr(iFWVMin); IStr(iFWV0)
    Print #1, sFWEffTF; sFWEffFT; sFWLA; sFWLB; sFWLC; _
        sFWLD; sFWLE
    
End Sub

Public Sub XCopy(FW As cFlyWheel)
' copy the data from FW
Dim ss(11) As String
    FW.getFlyWheel ss
    Me.setFlyWheel ss
End Sub

Private Sub Class_Initialize()
    sFWi = Zero
    sFWEffTF = Zero
    sFWEffFT = Zero
    sFWLA = Zero
    sFWLB = Zero
    sFWLC = Zero
    sFWLD = Zero
    sFWLE = Zero

End Sub


