VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cMotor"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'   Class cMotor

' This class contains Motor Data
' One cMotor object is included in each cTrain object

Private sMtrId As String * 36
Private sWDia0 As String * 10
Private sWDia1 As String * 10
Private sGR0 As String * 10
Private sGR1 As String * 10
Private sV0 As String * 10
Private sVOp As String * 10
Private sVMtr As String * 10
Private sSpd(4) As String * 10
Private sTE(4) As String * 10
Private sMI(4) As String * 10
Private iTCOpt As Integer
Private sLI(4) As String * 10

Private sEffChop0 As String * 10
Private sU1 As String * 10
Private sEffChop1 As String * 10
Private sEffBrake As String * 10
Private iFWOpt As Integer

Private sRSpd1 As String * 10
Private sRSpd2 As String * 10
Private sRR1 As String * 10
Private sRR2 As String * 10
Private sRR3 As String * 10

Public Property Get CtrlOpt() As Integer
    CtrlOpt = iTCOpt
End Property

Public Property Let CtrlOpt(ii As Integer)
    iTCOpt = ii
End Property

Public Property Get FWOpt() As Integer
    FWOpt = iFWOpt
End Property

Public Property Let FWOpt(ii As Integer)
    iFWOpt = ii
End Property

Public Sub getMtrSpecs(id As String, Spec() As String)
    id = sMtrId
    Spec(1) = sWDia0
    Spec(2) = sWDia1
    Spec(3) = sGR0
    Spec(4) = sGR1
    Spec(5) = sV0
    Spec(6) = sVOp
    Spec(7) = sVMtr

End Sub

Public Sub setMtrSpecs(id As String, Spec() As String)
    sMtrId = id
    sWDia0 = Spec(1)
    sWDia1 = Spec(2)
    sGR0 = Spec(3)
    sGR1 = Spec(4)
    sV0 = Spec(5)
    sVOp = Spec(6)
    sVMtr = Spec(7)

End Sub

Public Sub getMtrData(MData() As String)
Dim ii As Integer, ij As Integer
    For ii = 1 To 4
        ij = 4 * (ii - 1)
        MData(ij + 1) = sSpd(ii)
        MData(ij + 2) = sTE(ii)
        MData(ij + 3) = sMI(ii)
        MData(ij + 4) = ""
    Next ii

End Sub

Public Sub setMtrData(MData() As String)
Dim ii As Integer, ij As Integer
    For ii = 1 To 4
        ij = 4 * (ii - 1)
        sSpd(ii) = MData(ij + 1)
        sTE(ii) = MData(ij + 2)
        sMI(ii) = MData(ij + 3)
    Next ii

End Sub

Public Sub getChopper(LI() As String, Chop() As String)
' Chopper needs line currents, efficiencies and motor resistance
Dim ii As Integer
    For ii = 0 To 4
        LI(ii) = sLI(ii)
    Next ii
    Chop(1) = sEffChop0
    Chop(2) = sU1
    Chop(3) = sEffChop1
    Chop(4) = sEffBrake
    Chop(5) = sRR3
    
End Sub

Public Sub setChopper(LI() As String, Chop() As String)
Dim ii As Integer
    For ii = 0 To 4
        sLI(ii) = LI(ii)
    Next ii
    sEffChop0 = Chop(1)
    sU1 = Chop(2)
    sEffChop1 = Chop(3)
    sEffBrake = Chop(4)
    sRR3 = Chop(5)

End Sub

Public Sub getCam(Cam() As String)
' Cam needs Speed vs Resistance Data & Motor Resistance
    Cam(1) = sRSpd1
    Cam(2) = sRSpd2
    Cam(3) = sRR1
    Cam(4) = sRR2
    Cam(5) = sRR3
    
End Sub

Public Sub setCam(Cam() As String)
    sRSpd1 = Cam(1)
    sRSpd2 = Cam(2)
    sRR1 = Cam(3)
    sRR2 = Cam(4)
    sRR3 = Cam(5)

End Sub

Public Function ReadData() As Boolean
Dim LL$, t1, t2, t3, t4, t5, t6, t7, t8
    ReadData = False
    On Error GoTo InErr
    Line Input #1, LL$
    sMtrId = Left$(LL$, 36)
    sWDia0 = Val(Mid$(LL$, 41, 10))
    sWDia1 = Val(Mid$(LL$, 51, 10))
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sGR0 = t1
    sGR1 = t2
    sV0 = t3
    sVOp = t4
    sVMtr = t5
    '  9G
    If Not GetFour(t1, t2, t3, t4) Then Exit Function
    sSpd(1) = t1
    sSpd(2) = t2
    sSpd(3) = t3
    sSpd(4) = t4
    If Not GetFour(t1, t2, t3, t4) Then Exit Function
    sTE(1) = t1
    sTE(2) = t2
    sTE(3) = t3
    sTE(4) = t4
    If Not GetFour(t1, t2, t3, t4) Then Exit Function
    sMI(1) = t1
    sMI(2) = t2
    sMI(3) = t3
    sMI(4) = t4
    Line Input #1, LL$
    iTCOpt = Val(LL$)
    ' 9H
    If iTCOpt <> 1 Then
      If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
      sLI(0) = t1
      sLI(1) = t2
      sLI(2) = t3
      sLI(3) = t4
      sLI(4) = t5
      If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
      sEffChop0 = t1
      sU1 = t2
      sEffChop1 = t3
      sEffBrake = t4
      iFWOpt = t5
    End If
    '  9I
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sRSpd1 = t1
    sRSpd2 = t2
    sRR1 = t3
    sRR2 = t4
    sRR3 = t5
    
    ReadData = True
    Exit Function
InErr:
    ReadData = False

End Function

Public Sub WriteData()
    Print #1, sMtrId; Tab(41); sWDia0; sWDia1
    Print #1, sGR0; sGR1; sV0; sVOp; sVMtr
    Print #1, sSpd(1); sSpd(2); sSpd(3); sSpd(4)
    Print #1, sTE(1); sTE(2); sTE(3); sTE(4)
    Print #1, sMI(1); sMI(2); sMI(3); sMI(4)
    Print #1, IStr(iTCOpt)
    If iTCOpt <> 1 Then
        Print #1, sLI(0); sLI(1); sLI(2); sLI(3); sLI(4)
        Print #1, sEffChop0; sU1; sEffChop1; sEffBrake; IStr(iFWOpt)
    End If
    Print #1, sRSpd1; sRSpd2; sRR1; sRR2; sRR3

End Sub

Public Sub XCopy(MM As cMotor)
Dim s0(20) As String, LI(4) As String
Dim ii As Integer, ij As Integer
    With MM
        .getMtrSpecs sMtrId, s0
        sWDia0 = s0(1)
        sWDia1 = s0(2)
        sGR0 = s0(3)
        sGR1 = s0(4)
        sV0 = s0(5)
        sVOp = s0(6)
        sVMtr = s0(7)
        .getMtrData s0
        For ii = 1 To 4
            ij = 4 * (ii - 1)
            sSpd(ii) = s0(ij + 1)
            sTE(ii) = s0(ij + 2)
            sMI(ii) = s0(ij + 3)
        Next ii
        iTCOpt = .CtrlOpt
        iFWOpt = .FWOpt
        If iTCOpt = 1 Then
            ' cam
            .getCam s0
            sRSpd1 = s0(1)
            sRSpd2 = s0(2)
            sRR1 = s0(3)
            sRR2 = s0(4)
            sRR3 = s0(5)
        Else
            ' chopper
            .getChopper LI, s0
            sEffChop0 = s0(1)
            sU1 = s0(2)
            sEffChop1 = s0(3)
            sEffBrake = s0(4)
            sRR3 = s0(5)
            For ii = 0 To 4
                sLI(ii) = LI(ii)
            Next ii
        End If
        
    End With
End Sub

Private Sub Class_Initialize()
Dim ii As Integer
    sWDia0 = Zero
    sWDia1 = Zero
    sGR0 = Zero
    sGR1 = Zero
    sV0 = Zero
    sVOp = Zero
    sVMtr = Zero
    iTCOpt = 2  ' Default to chopper
    sLI(0) = Zero
    For ii = 1 To 4
        sSpd(ii) = Zero
        sTE(ii) = Zero
        sMI(ii) = Zero
        sLI(ii) = Zero
    Next ii
    sEffChop0 = Zero
    sU1 = Zero
    sEffChop1 = Zero
    sEffBrake = Zero
    iFWOpt = 1      ' default to no flywheel
    sRSpd1 = Zero
    sRSpd2 = Zero
    sRR1 = Zero
    sRR2 = Zero
    sRR3 = Zero
    
End Sub


