VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cRoute"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       cRoute.cls
'   Form  8A
Private sRouteID As String * 68  ' Route Name
Private sRtOrigin As String * 10 ' Location of Origin
Private sDelay As String * 10   ' Delay of first train
Private iTType1 As Integer      ' First train type
Private sVcMin As String * 10   ' Minimum Coasting Velocity
Private iCoastOpt As Integer    ' Coasting Option
Private iNPax0 As Integer       ' Number of passengers at origin
Private sDist0 As String * 10   ' Distance from RtOrigin to Portalto

' The following are for internal use only
' The corresponding property functions use the collection counts
Private iNTGrp As Integer
Private iNTrkSect As Integer
Private iNStop As Integer
Private iNSTP As Integer        ' Number of Train power profile points
Private iNLSect As Integer
'
' Form 8B
Public colTGroups As New Collection
' Form 8C
Public colTrack As New Collection
' Form 8D
Public colStops As New Collection
' Form 8E
Public colTrnPerf As New Collection
' Form 8F
Private colTSects As New Collection

Public Property Get id() As String
    id = sRouteID
    
End Property

Public Sub GetRoute(sid As String, s0 As String, s1 As String, s2 As String, _
        s3 As String, n1 As Integer, n2 As Integer, n3 As Integer)
' Get the non-tabular Route Data
    sid = sRouteID
    s0 = sRtOrigin
    s1 = sDelay
    s2 = sVcMin
    s3 = sDist0
    n1 = iTType1
    n2 = iCoastOpt
    n3 = iNPax0
    
End Sub

Public Sub SetRoute(sid As String, s0 As String, s1 As String, s2 As String, _
        s3 As String, n1 As Integer, n2 As Integer, n3 As Integer)
' Get the non-tabular Route Data
    sRouteID = sid
    sRtOrigin = s0
    sDelay = s1
    sVcMin = s2
    sDist0 = s3
    iTType1 = n1
    iCoastOpt = n2
    iNPax0 = n3
    
End Sub

Public Function ReadData() As Boolean
Dim LL$, ii As Integer
Dim t1, t2, t3, t4, t5, t6, t7, t8
Dim tg As cRtGroup, TT As cRtTrack, TS As cRtStop, tp As cRtTPerf
    ReadData = False
    On Error GoTo InErr
    Line Input #1, LL$
    sRouteID = Left$(LL$, 68)
    
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    sRtOrigin = t1
    iNTGrp = t2
    iNTrkSect = t3
    sDelay = t4
    iTType1 = Val(t5)
    sVcMin = t6
    iCoastOpt = Val(t7)

' Form 8B
    For ii = 1 To iNTGrp - 1
        Set tg = New cRtGroup
        If Not tg.ReadData Then Exit Function
        colTGroups.Add tg
    Next ii
' Form 8C
    If SESDS.TPOpt <> 3 Then
        For ii = 1 To iNTrkSect
            Set TT = New cRtTrack
            If Not TT.ReadData Then Exit Function
            colTrack.Add TT
        Next ii
    End If
' Form 8D
    If SESDS.TPOpt = 1 Then
        Line Input #1, LL$
        iNStop = Val(Mid$(LL$, 1, 10))
        iNPax0 = Val(Mid$(LL$, 11, 10))
        For ii = 1 To iNStop
            Set TS = New cRtStop
            If Not TS.ReadData Then Exit Function
            colStops.Add TS
        Next ii
    End If
' Form 8E
    If SESDS.TPOpt = 2 Or SESDS.TPOpt = 3 Then
    Line Input #1, LL$
    iNSTP = Val(LL$)
    For ii = 1 To iNSTP
        Set tp = New cRtTPerf
        If Not tp.ReadData Then Exit Function
        colTrnPerf.Add tp
    Next ii
    End If
' Form 8F
    Dim sx As Integer
    Line Input #1, LL$
    iNLSect = Val(Mid$(LL$, 1, 10))
    sDist0 = Mid$(LL$, 11, 10)
    For ii = 1 To iNLSect
        Line Input #1, LL$
        sx = Val(LL$)
        colTSects.Add sx
    Next ii
    ReadData = True
    Exit Function
InErr:
    ReadData = False
End Function


Public Sub TGroupList(gg As Grid)
' Load the train groups into grid gg
Dim tg As cRtGroup
Dim n1 As Integer, n2 As Integer, n3 As Integer
    gg.AddItem " ", 0
    gg.Rows = 1
    For Each tg In colTGroups
        tg.getRtGroup n1, n2, n3
        With tg
            gg.AddItem Str(n1) + Chr(9) + Str(n2) + Chr(9) + Str(n3)
        End With
    Next
    If gg.Rows > 1 Then
        gg.RemoveItem 0
        gg.AddItem " "      ' add a blank line at the end
    End If
    
End Sub

Public Sub TGroupSave(gg As Grid)
Dim tg As cRtGroup
Dim ii As Integer
Dim n1 As Integer, n2 As Integer, n3 As Integer
    ' clear the collection
    For ii = 1 To colTGroups.Count
        colTGroups.Remove 1
    Next ii
    
    For ii = 0 To gg.Rows - 1
        gg.Row = ii
        gg.Col = 0
        n1 = Val(gg.Text)
        If n1 > 0 Then
            gg.Col = 1
            n2 = Val(gg.Text)
            gg.Col = 2
            n3 = Val(gg.Text)
            Set tg = New cRtGroup
            tg.setRtGroup n1, n2, n3
            colTGroups.Add tg
        End If
    Next ii
End Sub
Public Sub TStopList(gg As Grid)
' Load the train groups into grid gg
Dim tg As cRtStop
Dim s1 As String, s2 As String, s3 As String
    gg.AddItem " ", 0
    gg.Rows = 1
    For Each tg In colStops
        tg.getRtStop s1, s2, s3
        With tg
            gg.AddItem s1 + Chr(9) + s2 + Chr(9) + s3
        End With
    Next
    If gg.Rows > 1 Then
        gg.RemoveItem 0
        gg.AddItem " "
    End If
    
End Sub

Public Sub TStopSave(gg As Grid)
Dim tg As cRtStop
Dim s1 As String, s2 As String, s3 As String
Dim ii As Integer
    ' clear the collection
    For ii = 1 To colStops.Count
        colStops.Remove 1
    Next ii
    
    For ii = 0 To gg.Rows - 1
        gg.Row = ii
        gg.Col = 0
        s1 = gg.Text
        If Trim(s1) <> "" And Val(s1) > 0 Then
            gg.Col = 1
            s2 = gg.Text
            gg.Col = 2
            s3 = gg.Text
            Set tg = New cRtStop
            tg.setRtStop s1, s2, s3
            colStops.Add tg
        End If
    Next ii

End Sub

Public Sub TPerfList(gg As Grid)
' Load the train groups into grid gg
Dim tg As cRtTPerf
Dim s1 As String, s2 As String, s3 As String, s4 As String
    gg.AddItem " ", 0
    gg.Rows = 1
    For Each tg In colTrnPerf
        tg.getRtTPerf s1, s2, s3, s4
        With tg
            gg.AddItem s1 + Chr(9) + s2 + Chr(9) + s3 + Chr(9) + s4
        End With
    Next
    If gg.Rows > 1 Then
        gg.RemoveItem 0
        gg.AddItem " "
    End If

End Sub

Public Sub TPerfSave(gg As Grid)
Dim tg As cRtTPerf
Dim s1 As String, s2 As String, s3 As String, s4 As String
Dim ii As Integer
    ' clear the collection
    For ii = 1 To colTrnPerf.Count
        colTrnPerf.Remove 1
    Next ii
    
    For ii = 0 To gg.Rows - 1
        gg.Row = ii
        gg.Col = 0
        s1 = gg.Text
        If Trim(s1) <> "" And Val(s1) > 0 Then
            gg.Col = 1
            s2 = gg.Text
            gg.Col = 2
            s3 = gg.Text
            gg.Col = 3
            s4 = gg.Text
            Set tg = New cRtTPerf
            tg.setRtTPerf s1, s2, s3, s4
            colTrnPerf.Add tg
        End If
    Next ii

End Sub

Public Sub TrackList(gg As Grid)
' Load the train track geometry into grid gg
Dim tg As cRtTrack
Dim n1 As Integer, n2 As Integer
Dim s1 As String, s2 As String, s3 As String, s4 As String, s5 As String
    gg.AddItem " ", 0
    gg.Rows = 1
    For Each tg In colTrack
        tg.getRtTrack s1, s2, s3, s4, s5, n1, n2
        With tg
            gg.AddItem s1 + Chr(9) + s2 + Chr(9) + s3 + Chr(9) + s4 + _
                Chr(9) + s5 + Chr(9) + Str(n1) + Chr(9) + Str(n2)
        End With
    Next
    If gg.Rows > 1 Then
        gg.RemoveItem 0
        gg.AddItem " "
    End If

End Sub

Public Sub TrackSave(gg As Grid)
Dim tg As cRtTrack
Dim n1 As Integer, n2 As Integer
Dim s1 As String, s2 As String, s3 As String, s4 As String, s5 As String
Dim ii As Integer
    ' clear the collection
    For ii = 1 To colTrack.Count
        colTrack.Remove 1
    Next ii
    
    For ii = 0 To gg.Rows - 1
        gg.Row = ii
        gg.Col = 0
        s1 = gg.Text
        If Trim(s1) <> "" And Val(s1) > 0 Then
            gg.Col = 1
            s2 = gg.Text
            gg.Col = 2
            s3 = gg.Text
            gg.Col = 3
            s4 = gg.Text
            gg.Col = 4
            s5 = gg.Text
            gg.Col = 5
            n1 = Val(gg.Text)
            gg.Col = 6
            n2 = Val(gg.Text)
            Set tg = New cRtTrack
            tg.setRtTrack s1, s2, s3, s4, s5, n1, n2
            colTrack.Add tg
        End If
    Next ii

End Sub

Public Sub TSectList(LL As ListBox)
'  Load the Route Section List into LL
Dim sid
    LL.Clear
    For Each sid In colTSects
        LL.AddItem sid
    Next
    LL.AddItem " "
    
End Sub

Public Sub TSectSave(LL As ListBox)
' Save the Route Section list from the Listbox LL
Dim sid As Integer, ii As Integer
On Error Resume Next
    ' clear the collection
    For ii = 1 To colTSects.Count
        colTSects.Remove 1
    Next ii
    
    For ii = 0 To LL.ListCount - 1
        sid = Val(LL.List(ii))
        If sid <> 0 Then colTSects.Add sid
    Next ii
End Sub

Public Sub WriteData()
' Write the data for one Route
Dim ii As Integer, ngrp As Integer
    ' Avoid printing empty routes
    If Trim(sRouteID) = "" Then Exit Sub
    Print #1, sRouteID
    ngrp = colTGroups.Count + 1
    Print #1, sRtOrigin; IStr(ngrp); IStr(colTrack.Count); sDelay; _
        IStr(iTType1); sVcMin; IStr(iCoastOpt)
    If ngrp > 1 Then
        For ii = 1 To colTGroups.Count
            colTGroups(ii).WriteData
        Next ii
    End If
    If SESDS.TPOpt <> 3 Then
        For ii = 1 To colTrack.Count
            colTrack(ii).WriteData
        Next ii
    End If
    If SESDS.TPOpt = 1 Then
        Print #1, IStr(colStops.Count); IStr(iNPax0)
        For ii = 1 To colStops.Count
            colStops(ii).WriteData
        Next ii
    End If
    If SESDS.TPOpt = 2 Or SESDS.TPOpt = 3 Then
        Print #1, IStr(colTrnPerf.Count)
        For ii = 1 To colTrnPerf.Count
            colTrnPerf(ii).WriteData
        Next ii
    End If
    
    ' Form 8F - Section List
    Print #1, IStr(colTSects.Count); sDist0
    For ii = 1 To colTSects.Count
        Print #1, IStr(colTSects(ii))
    Next ii
End Sub

Public Sub XCopy(rr As cRoute)
Dim ii As Integer
    rr.GetRoute sRouteID, sRtOrigin, sDelay, sVcMin, _
        sDist0, iTType1, iCoastOpt, iNPax0
    With rr
        For ii = 1 To .colTGroups.Count
            colTGroups.Add .colTGroups(ii)
        Next ii
        For ii = 1 To .colTrack.Count
            colTrack.Add .colTrack(ii)
        Next ii
        For ii = 1 To .colStops.Count
            colStops.Add .colStops(ii)
        Next ii
        For ii = 1 To .colTrnPerf.Count
            colTrnPerf.Add .colTrnPerf(ii)
        Next ii
    End With
End Sub

Private Sub Class_Initialize()
    sRouteID = ""
    sRtOrigin = Zero
    sDelay = Zero
    iTType1 = 1
    sVcMin = Zero
    iCoastOpt = 0
    iNPax0 = 0
    sDist0 = Zero
    
End Sub


Private Sub Class_Terminate()
' Clear the collections
Dim ii As Integer
    For ii = 1 To colTGroups.Count
        colTGroups.Remove 1
    Next ii
    Set colTGroups = Nothing
    For ii = 1 To colTrack.Count
        colTrack.Remove 1
    Next ii
    Set colTrack = Nothing
    For ii = 1 To colStops.Count
        colStops.Remove 1
    Next ii
    Set colStops = Nothing
    For ii = 1 To colTrnPerf.Count
        colTrnPerf.Remove 1
    Next ii
    Set colTrnPerf = Nothing
    For ii = 1 To colTSects.Count
        colTSects.Remove 1
    Next ii
    Set colTSects = Nothing
End Sub


