VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cRoutes"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit
'       cRoutes.cls
' This is the Collection of Routes

Private colRoutes As Collection

Private BufferRoute As cRoute

Public Function Add(ii As Integer) As cRoute
Dim rr As cRoute
    Set rr = New cRoute
    If ii = 0 Then
        colRoutes.Add rr
    Else
        colRoutes.Add rr, before:=ii
    End If
    Set Add = rr
    
End Function

Public Sub Copy(ii As Integer)
' Copy Route ii to buffer
    Set BufferRoute = New cRoute
    BufferRoute.XCopy colRoutes(ii)
    
End Sub

Public Sub Cut(ii As Integer)
' Copy Route ii to buffer
    Set BufferRoute = New cRoute
    BufferRoute.XCopy colRoutes(ii)
    colRoutes.Remove ii
    
End Sub

Public Sub Paste(ii As Integer)
' Paste the contents of the buffer to the list at ii
Dim ff As cRoute
    Set ff = New cRoute
    ff.XCopy BufferRoute
    colRoutes.Add ff, before:=ii
    
End Sub

Public Property Get Count() As Integer
    Count = colRoutes.Count
    
End Property

Public Sub Delete(indx As Integer)
    colRoutes.Remove indx
    
End Sub

Public Function ReadRoutes(nn As Integer) As Boolean
Dim ii As Integer
Dim nx As cRoute
    ReadRoutes = False
    For ii = 1 To nn
        Set nx = New cRoute
        If Not nx.ReadData Then Exit Function
        colRoutes.Add nx
    Next ii
    ReadRoutes = True
End Function

Public Property Get Route(Index As Integer)
    If Index <= colRoutes.Count Then
        Set Route = colRoutes(Index)
    Else
        Set Route = Nothing
    End If
    
End Property

Public Sub WriteRoutes()
' Loop to write each route
Dim ii As Integer
    For ii = 1 To colRoutes.Count
        colRoutes(ii).WriteData
    Next ii
End Sub


Private Sub Class_Initialize()
    Set colRoutes = New Collection
    
End Sub


Private Sub Class_Terminate()
Dim ii As Integer
    For ii = 1 To colRoutes.Count
        colRoutes.Remove 1
    Next ii
    Set BufferRoute = Nothing
    
End Sub


