VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'       cSection.cls

Private iID As Integer
Private iStartNode As Integer
Private iStopNode As Integer
Private sInitAir As String * 10

Private NSegs As Integer
Private colsegs As New Collection


Public Sub DelSeg(ss As cSegment)
' delete the argument segment from colSegs
Dim ii As Integer
    For ii = 1 To colsegs.Count
        If colsegs(ii) Is ss Then
            colsegs.Remove ii
            Exit For
        End If
    Next ii
    
End Sub

Public Function InsertSeg(ss As cSegment, Bfore As Boolean) As cSegment
' Create a new segment before (or after) segment ss
Dim ii As Integer, sx As cSegment
    Set sx = New cSegment
    Set sx.Daddy = Me
    For ii = 1 To colsegs.Count
        If colsegs(ii) Is ss Then
            If Bfore Then
               colsegs.Add Item:=sx, before:=ii
            Else
               colsegs.Add Item:=sx, after:=ii
            End If
            Exit For
        End If
    Next ii
    Set InsertSeg = sx
End Function


Public Property Let nLSegs(nn As Integer)
' This is a little tricky since it implies changing the
' number of segments associated with this section.
' If the number of segments is increased, add copies the last existing
' section at the end of the list.
' If the number of segments is decreased . . . do not permit change!
' Display a message box to explain segments must be deleted on segment
' form
Dim nold As Integer, ii As Integer, nx As Integer
Dim ss As cSegment
    nold = NSegs
    If nn < nold Then
        MsgBox "Cannot decrease number of segments." + Chr(13) + _
            "Delete Segments on the Line Segment Form"
    ElseIf nn > nold Then
        nx = colsegs.Count
        For ii = nx + 1 To nn
            Set ss = AddSeg
            ss.XCopy colsegs(nx)
        Next ii
    End If
End Property

Public Function ReadSegs() As Boolean
' Read the segment data for this section
Dim ii As Integer
Dim ss As cSegment
    ReadSegs = False
    For ii = 1 To NSegs
        Set ss = New cSegment
        If Not ss.ReadData Then Exit Function
        Set ss.Daddy = Me
        colsegs.Add ss
    Next ii
    ReadSegs = True

End Function

Public Property Get Segment(N As Integer) As cSegment
    If N <= colsegs.Count Then
        Set Segment = colsegs.Item(N)
    Else
        Set Segment = Nothing
    End If
End Property

Property Get nLSegs() As Integer
    nLSegs = colsegs.Count
    
End Property


Public Function AddSeg() As cSegment
' add a new segment at index ix
Dim ss As cSegment
    Set ss = New cSegment
    Set ss.Daddy = Me
    ss.id = iID
    colsegs.Add Item:=ss
    NSegs = colsegs.Count
    Set AddSeg = ss

End Function
Property Get id() As Integer
    id = iID
    
End Property

Property Let id(xID As Integer)
    iID = xID
    
End Property


Property Get InitAir() As String
    InitAir = sInitAir
    
End Property

Property Let InitAir(sAir As String)
    sInitAir = sAir
    
End Property

Public Sub ReadData()
' Read the section record (Form 2A) from the input file
Dim t1, t2, t3, t4, t5, t6, t7, t8
    GetLine t1, t2, t3, t4, t5, t6, t7, t8
    iID = Val(t1)
    iStartNode = Val(t2)
    iStopNode = Val(t3)
    NSegs = Val(t4)
    sInitAir = t5

End Sub

Property Get StartNode() As Integer
    StartNode = iStartNode
    
End Property

Property Let StartNode(iNode As Integer)
    iStartNode = iNode
    
End Property


Property Let StopNode(iNode As Integer)
    iStopNode = iNode
    
End Property


Property Get StopNode() As Integer
    StopNode = iStopNode
    
End Property

Public Sub WriteData()
'
    Print #1, IStr(iID); IStr(iStartNode); IStr(iStopNode); _
        IStr(colsegs.Count); sInitAir
    
End Sub


Public Sub WriteSegs()
'
Dim Seg As cSegment
    For Each Seg In colsegs
        Seg.WriteData
    Next
End Sub


Public Sub XCopy(ssrc As cSection)
' Copy the contents of section ssrc
Dim nn As Integer, ii As Integer
Dim ss As cSegment
    With ssrc
        iStartNode = .StartNode
        iStopNode = .StopNode
        sInitAir = .InitAir
        nn = .nLSegs
        ' copy all the segments
        For ii = 1 To nn
          Set ss = AddSeg
          ss.XCopy .Segment(ii)
        Next ii
    End With

End Sub


Private Sub Class_Initialize()
    NSegs = 0
    
End Sub

Private Sub Class_Terminate()
' Delete the segments
Dim i As Integer
    For i = 1 To colsegs.Count
        colsegs.Remove 1
    Next i
End Sub


