VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cTrains"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit

'  Class cTrains

'  This class is a container for the train data.
'  It contains special handling to ensure completeness of all
'  cTrain objects and it manages the cTrain default and buffer objects.
'
Private colTrains As Collection

Private DefaultTrain As cTrain
Private BufferTrain As cTrain
Public Property Get Train(indx As Integer) As cTrain
    Set Train = colTrains(indx)
    
End Property

Public Property Get Count() As Integer
    Count = colTrains.Count
    
End Property
Public Function Add(indx As Integer)
Dim trn As cTrain
    Set trn = New cTrain
    If indx = 0 Then
        colTrains.Add trn
    Else
        colTrains.Add trn, before:=indx
    End If
End Function

Public Sub Delete(indx As Integer)
    colTrains.Remove indx
    
End Sub

Public Sub Copy(ii As Integer)
' Copy Train ii to buffer
    Set BufferTrain = New cTrain
    BufferTrain.XCopy colTrains(ii)
    
End Sub

Public Sub Cut(ii As Integer)
' Copy Train ii to buffer
    Set BufferTrain = New cTrain
    BufferTrain.XCopy colTrains(ii)
    colTrains.Remove ii
    
End Sub

Public Sub Paste(ii As Integer)
' Paste the contents of the buffer to the list at ii
Dim ff As cTrain
    Set ff = New cTrain
    ff.XCopy BufferTrain
    colTrains.Add ff, before:=ii
    
End Sub
Public Function ReadTrains(nt As Integer) As Boolean
' Read nt trains from the data file
Dim ii As Integer
Dim TT As cTrain
    ReadTrains = False
    For ii = 1 To nt
        Set TT = New cTrain
        If Not TT.ReadData Then Exit Function
        colTrains.Add TT
    Next ii
    ReadTrains = True
    
End Function

Public Sub WriteTrains()
Dim ii As Integer
    For ii = 1 To colTrains.Count
        colTrains(ii).WriteData
    Next ii
End Sub

Private Sub Class_Initialize()
    Set colTrains = New Collection
    
End Sub


Private Sub Class_Terminate()
Dim ii As Integer
    For ii = 1 To colTrains.Count
        colTrains.Remove 1
    Next ii
End Sub

