VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cVShaft"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' SESIN - Subway Environment Simulation Input Manager
' Volpe Transportation Systems Center
' Written by: ICF Kaiser Engineers, Oakland, CA
' Orig: Jan '97

Option Explicit
'
'       cVShaft.cls
' This class defines the shaft data for each vent.
' Since there is only one shaft record per vent, there
' is no cVShaftS.cls to manage collections. Each Vent Section
' object contains one cVShaft object.

Private iID As Integer
Private iVtype As Integer
Private sTitle As String * 36
Private iNSeg As Integer
Private iNSubSeg As Integer
Private sGrate As String * 10
Private sVGrate As String * 10
Private sWSTemp As String * 10
Private sTDB0 As String * 10
Private sTWB0 As String * 10
Private sStackHt As String * 10
Private nFanType As Integer
Private sFanOn As String * 10
Private sFanOff As String * 10
Private nFanDir As Integer

Public Daddy As cVent

Public colVSegs As Collection

Property Get id() As Integer
    id = iID
    
End Property


Property Let id(ii As Integer)
    iID = ii
    
End Property

Property Get VType() As Integer
    VType = iVtype
    
End Property

Property Let VType(ii As Integer)
    iVtype = ii
    
End Property

Property Get NSeg() As Integer
    NSeg = colVSegs.Count
    
End Property

'Property Let NSeg(ii As Integer)
'    iNSeg = ii
'
'End Property

Property Get NSubSeg() As Integer
    NSubSeg = iNSubSeg
    
End Property

Property Let NSubSeg(ii As Integer)
    iNSubSeg = ii
    
End Property

Property Get FanType() As Integer
    FanType = nFanType
    
End Property

Property Let FanType(ii As Integer)
    nFanType = ii
    
End Property

Property Get FanDir() As Integer
    FanDir = nFanDir
    
End Property

Property Let FanDir(ii As Integer)
    nFanDir = ii
    
End Property

Property Get Title() As String
    Title = sTitle
    
End Property

Property Let Title(ss As String)
    sTitle = ss
    
End Property

Property Get Grate() As String
    Grate = sGrate
    
End Property

Property Let Grate(ss As String)
    sGrate = ss
    
End Property

Property Get VGrate() As String
    VGrate = sVGrate
    
End Property

Property Let VGrate(ss As String)
    sVGrate = ss
    
End Property


Property Get WSTemp() As String
    WSTemp = sWSTemp
    
End Property

Property Let WSTemp(ss As String)
    sWSTemp = ss
    
End Property

Property Get TDB0() As String
    TDB0 = sTDB0
    
End Property

Property Let TDB0(ss As String)
    sTDB0 = ss
    
End Property

Property Get TWB0() As String
    TWB0 = sTWB0
    
End Property

Property Let TWB0(ss As String)
    sTWB0 = ss
    
End Property

Property Get StackHt() As String
    StackHt = sStackHt
    
End Property

Property Let StackHt(ss As String)
   sStackHt = ss
    
End Property

Property Get FanOn() As String
    FanOn = sFanOn
    
End Property

Property Let FanOn(ss As String)
    sFanOn = ss
    
End Property

Property Get FanOff() As String
    FanOff = sFanOff
    
End Property

Property Let FanOff(ss As String)
    sFanOff = ss
    
End Property

Public Function ReadData() As Boolean
Dim LL$, t1, t2, t3, t4, t5, t6, t7, t8
Dim k As Integer
Dim vs As cVentSeg
    ReadData = False
    On Error GoTo InErr
    Line Input #1, LL$
    iID = Val(Mid$(LL$, 1, 10))
    iVtype = Val(Mid$(LL$, 11, 10))
    sTitle = Mid$(LL$, 21, 35)
    If Not GetLine(t1, t2, t3, t4, t5, t6, t7, t8) Then Exit Function
    iNSeg = Val(t1)
    iNSubSeg = Val(t2)
    sGrate = t3
    sVGrate = t4
    sWSTemp = t5
    sTDB0 = t6
    sTWB0 = t7
    sStackHt = t8
    
    If SESDS.NFans > 0 Then
        If Not GetFour(t1, t2, t3, t4) Then Exit Function
        nFanType = Val(t1)
        sFanOn = t2
        sFanOff = t3
        nFanDir = Val(t4)
    End If
    
    For k = 1 To iNSeg   ' loop thru segments
        Set vs = New cVentSeg
        If Not vs.ReadData Then Exit Function
        colVSegs.Add vs
    Next k
    ReadData = True
    Exit Function
InErr:
    ReadData = False
    
End Function

Public Sub WriteData()
' Write data for one shaft to the data file
Dim ii As Integer
    Print #1, IStr(iID); IStr(iVtype); sTitle
    Print #1, IStr(colVSegs.Count); IStr(iNSubSeg); sGrate; sVGrate; _
        sWSTemp; sTDB0; sTWB0; sStackHt
    If SESDS.NFans > 0 Then
        Print #1, IStr(nFanType); sFanOn; sFanOff; FanDir
    End If
    ' Loop through the vent segments
    For ii = 1 To colVSegs.Count
        colVSegs(ii).WriteData
    Next ii
End Sub

Public Function AddVSeg() As cVentSeg
Dim ss As cVentSeg
    Set ss = New cVentSeg
    colVSegs.Add ss
    Set AddVSeg = ss
End Function

Public Sub ClearVSegs()
' Clear all segments
Dim ii As Integer
For ii = 1 To colVSegs.Count
    colVSegs.Remove 1
Next ii
End Sub

Public Sub SubList(gg As Grid)
' Load vent Segments into gg
Dim ss As cVentSeg
Dim xs As String, SL As String, sA As String, SP As String
Dim HL1 As String, HL2 As String, HL3 As String, HL4 As String
    gg.AddItem " ", 0       ' add a blank row
    gg.Rows = 1             ' delete all but last
    For Each ss In colVSegs
        ss.getVSeg SL, sA, SP, HL1, HL2, HL3, HL4
        xs = SL + Chr(9) + sA + Chr(9) + SP + Chr(9) + _
           HL1 + Chr(9) + HL2 + Chr(9) + HL3 + Chr(9) + HL4
        gg.AddItem xs
    Next
    If gg.Rows > 1 Then
        gg.RemoveItem 0
        gg.AddItem " "
    End If

End Sub

Public Sub XCopy(vs As cVShaft)
' Copy data from vs
Dim ii As Integer
    With vs
        iNSeg = .NSeg
        iNSubSeg = .NSubSeg
        sTitle = .Title
        iVtype = .VType
        sGrate = .Grate
        sVGrate = .VGrate
        sWSTemp = .WSTemp
        sTDB0 = .TDB0
        sTWB0 = .TWB0
        sStackHt = .StackHt
        nFanType = .FanType
        sFanOn = .FanOn
        sFanOff = .FanOff
        nFanDir = .FanDir
        Dim ss As cVentSeg
        For ii = 1 To colVSegs.Count
            colVSegs.Remove ii
        Next ii
        For ii = 1 To iNSeg
            Set ss = New cVentSeg
            ss.XCopy .colVSegs(ii)
            colVSegs.Add ss
        Next ii
    End With
End Sub

Private Sub Class_Initialize()
    Set colVSegs = New Collection
    
End Sub

Private Sub Class_Terminate()
'    Release all subsegments and steady state heat sources
    ClearVSegs
    
End Sub

